#include "../C-Engine/CEngine/Object.hpp"
#include "../C-Engine/CEngine/Engine.hpp"
#include "../C-Engine/CEngine/Script.hpp"

#include "../C-Engine/CPhysics/Transforms.hpp"
#include "../C-Engine/CPhysics/Rigibodys.hpp"

#include "../C-Engine/CRendering/Render.hpp"
#include "../C-Engine/CRendering/Animation.hpp"
#include "../C-Engine/CRendering/Sprite.hpp"
#include "../C-Engine/CRendering/TilesMapping.hpp"

extern "C"
{
#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../C-Engine/CExtraLib/input.h"
#include "../C-Engine/CExtraLib/MonochromeLib.h"
#include "../C-Engine/CExtraLib/FonctionC.h"
}


Script::Script()
{
    OConteneur = NULL;
    EConteneur = NULL;
}

void Script::AffectObject(Object * OV)
{
    OConteneur = OV;
}

void Script::AffectEngine(Engine * EV)
{
    EConteneur = EV;
}

void Script::SetXY( double x , double y)
{
    OConteneur->OTransforms->SetXY( x , y);
}

void Script::Move( int x , int y)
{
    OConteneur->ORigibody->Move( x , y);
}

void Script::SetIt( int i)
{
    OConteneur->ORender->SetIt(i);
}

int Script::GetX()
{
    return OConteneur->OTransforms->GetX();
}

int Script::GetY()
{
    return OConteneur->OTransforms->GetY();
}

int Script::SizeX()
{
    return OConteneur->ORender->GetSizeX();
}

int Script::SizeY()
{
    return OConteneur->ORender->GetSizeY();
}

Object * Script::GetObject()
{
    return OConteneur;
}

Engine * Script::GetEngine()
{
    if(OConteneur != NULL) return OConteneur->Conteneur;
    else return EConteneur;
}

void Script::Start()
{
}

void Script::Update()
{
}

void Script::UpdateEverySecond()
{
}




