#include "fxlib.h"
#include "stdlib.h"
#include "stdio.h"
#include "MonochromeLib.h"






/****************************************/
/*                                                               */
/*       Code de compatibilit SH4         */
/*                                                               */
/****************************************/

#define __KEYBIOS_H__
#define KEY_CTRL_F1 		79
#define KEY_CTRL_F2 		69
#define KEY_CTRL_F3 		59
#define KEY_CTRL_F4 		49
#define KEY_CTRL_F5 		39
#define KEY_CTRL_F6 		29
#define KEY_CTRL_SHIFT 	78
#define KEY_CTRL_OPTN 	68
#define KEY_CTRL_VARS 	58
#define KEY_CTRL_MENU 	48
#define KEY_CTRL_LEFT 	38
#define KEY_CTRL_UP 		28
#define KEY_CTRL_ALPHA 	77
#define KEY_CHAR_SQUARE	67
#define KEY_CHAR_POW 	57
#define KEY_CTRL_EXIT 		47
#define KEY_CTRL_DOWN 	37
#define KEY_CTRL_RIGHT 	27
#define KEY_CTRL_XTT 		76
#define KEY_CHAR_LOG 	66
#define KEY_CHAR_LN 		56
#define KEY_CHAR_SIN 		46
#define KEY_CHAR_COS 	36
#define KEY_CHAR_TAN 	26
#define KEY_CHAR_FRAC	75
#define KEY_CTRL_FD 		65
#define KEY_CHAR_LPAR	55
#define KEY_CHAR_RPAR 	45
#define KEY_CHAR_COMMA	35
#define KEY_CHAR_STORE 	25
#define KEY_CHAR_7 		74
#define KEY_CHAR_8 		64
#define KEY_CHAR_9 		54
#define KEY_CTRL_DEL 		44
#define KEY_CTRL_AC 		32
#define KEY_CHAR_4 		73
#define KEY_CHAR_5 		63
#define KEY_CHAR_6 		53
#define KEY_CHAR_MULT 	43
#define KEY_CHAR_DIV 		33
#define KEY_CHAR_1 		72
#define KEY_CHAR_2 		62
#define KEY_CHAR_3 		52
#define KEY_CHAR_PLUS 	42
#define KEY_CHAR_MINUS 	32
#define KEY_CHAR_0 		71
#define KEY_CHAR_DP 		61
#define KEY_CHAR_EXP 	51
#define KEY_CHAR_PMINUS	41
#define KEY_CTRL_EXE 		31

#ifndef OS2Change
	#define OS2Change
	#ifndef OS2Change_GetOS2
		#define OS2Change_GetOS2
		typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
		const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
		#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
		int OSVersionAsInt(void) {
			unsigned char mainversion;
			unsigned char minorversion;
			unsigned short release;
			unsigned short build;
			GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
			return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
		}
		
		#define isOS2 (OSVersionAsInt() >= 0x02020000)
		#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
	#endif
	
	#ifndef OS2Change_Keyboard
		#define OS2Change_Keyboard
		
		void delay(void) {
			char i;
			for (i=0; i<5; i++){};
		}
		
		unsigned char CheckKeyRow(unsigned char code) {
			unsigned char result=0;
			short*PORTB_CTRL=(void*)0xA4000102;
			short*PORTM_CTRL=(void*)0xA4000118;
			char*PORTB=(void*)0xA4000122;
			char*PORTM=(void*)0xA4000138;
			char*PORTA=(void*)0xA4000120;
			short smask;
			char cmask;
			unsigned char column, row;
			column = code>>4;
			row = code &0x0F;
			smask = 0x0003 << (( row %8)*2);
			cmask = ~( 1 << ( row %8) );
			
			if(row <8) {
				*PORTB_CTRL = 0xAAAA ^ smask;
				*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
				delay();
				*PORTB = cmask;
				*PORTM = (*PORTM & 0xF0 ) | 0x0F;
			}else{
				*PORTB_CTRL = 0xAAAA;
				*PORTM_CTRL = ((*PORTM_CTRL & 0xFF00 ) | 0x00AA)  ^ smask;
				delay();
				*PORTB = 0xFF;
				*PORTM = (*PORTM & 0xF0 ) | cmask;
			}
			delay();
			result = (~(*PORTA))>>column & 1;
			delay();
			*PORTB_CTRL = 0xAAAA;
			*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
			delay();
			*PORTB_CTRL = 0x5555;
			*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x0055;
			delay();
			return result;
		}
		unsigned char KeyDown(unsigned char keycode) {
			unsigned short key[8];
			const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
			if(isOS2) {
				unsigned char row = keycode%10;
				memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
			 
				return (0 != (key[row >> 1] & 1 << keycode / 10 - 1 + ((row & 1) << 3)));
			}else{
				return CheckKeyRow((keycode % 10) + ((keycode / 10 - 1) << 4));
			}
		}
		
		unsigned char GetKeyMod(unsigned int *key) {
			unsigned char x, ret;
			ret = GetKey(key);
			for(x = 0; x < 80; x++) {
				if(KeyDown(x)) {
					*key = x;
					break;
				}
			}
			return ret;
		}
		
		#define IsKeyDown(x) KeyDown(x)
		#define IsKeyUp(x) !KeyDown(x)
		#define GetKey(x) GetKeyMod(x)
	#endif
#endif
#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum) {
return INIT_ADDIN_APPLICATION(isAppli, OptionNum); }
#pragma section













/****************************************/
/*                                                               */
/*         Initialisation de l'alatoire         */
/*                                                               */
/****************************************/

static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};
static int (*SysCall)(int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;
int RTC_getTicks()
{
     return (*SysCall)(0, 0, 0, 0, 0x3B);
}











/**************************************************/
/*                                                                                */
/*  Fonction de gnration alatoire du monde  */
/*                                                                                */
/**************************************************/

 int generation_monde(unsigned char monde1[][50], char monde2[][50], char monde3[][50], char monde4[][50])
 {
    int random;
    int X;
    int Y;
    int X_2;
    int Y_2;
    int premier_X;
    int premier_Y;
    int dernier_X;
    int dernier_Y;
    int taille; //"rayon" moyen du continent
    int i; // variale pour le for
    int j; //variable pour le for
    int condition; //variable de condtion pour ne pas modifier Y
    int cote_gauche_X[100]; // Les coord X du contour gauche du continent
    int cote_droit_X[100]; // Les coord X du contour droit du continent
    int Y_pour_liste;
    int nombre_de_continent;
    int nombre_de_continent_crees;
    char buffer[50];
    
    //Initialisation de l'alatoire
    random = RTC_getTicks();
    srand(random);
    
    nombre_de_continent = rand();
    nombre_de_continent = nombre_de_continent %2 + 1;
    
    // ~~~~~~ Gnration de "nombre_de_continent" continent ~~~~~~ //
    
    for (nombre_de_continent_crees = 0; nombre_de_continent_crees < nombre_de_continent; nombre_de_continent_crees ++)
    {
    //Ce qui va suivre n'est pas indent en fonction du for car il  t rajout aprs et qu je n'ai pas consacr le peu de temps que j'ai  le faire
    
    
    Y_pour_liste = 0;
    
    
    // Position du premier "bloc" du continent compris entre 2 et 25 en X et entre 2 et 25 en Y
    X = rand();
    Y = rand();
    
    if (nombre_de_continent_crees == 0)
    {
        X = X %23 + 2;
        Y = Y %23 + 2;
    }
    
    if (nombre_de_continent_crees == 1)
    {
        X = X %25 + 50;
        Y = Y %23 + 2;
    }
    
    if (nombre_de_continent_crees == 2)
    {
        X = X %30 + 30;
        Y = Y %20 + 40;
    }
    
    // Sauvegarde de la position du premier bloc
    premier_X = X;
    premier_Y = Y;
    
    //Taille moyenne du continent
    taille = rand();
    taille = taille %10 + 10;
      
        
    // Contour du continent : Cette partie  du code est plutt moche dsol mais si vous lisez ce message, c'est que je n'ai malheureusement pas eu le temps de la modifier :(
    for (j = 0; j < 4; j++)
    {
    
        sprintf (buffer,"j : %d", j);
        PrintXY(0, 57,buffer,0);
        sprintf (buffer,"X1 : %d", premier_X);
        PrintXY(0, 47,buffer,0);
        sprintf (buffer,"Y1 : %d", premier_Y);
        PrintXY(50, 47,buffer,0);
        
        ML_display_vram();
    
        for (i = 0; i < taille  + 1;  i++)
        {
            //On sauvegarde X et Y
            X_2 = X;
            Y_2 = Y;
        
            //On continue de crer le contour du continent
            random = rand();
            random = random %2;
            if (j == 0 || j == 3) { X = X + random; }
            if (j == 1 || j == 2) { X = X - random; }
            random = rand();
            random = random %2;
            if (j == 0 || j == 1) { Y = Y + random + 1; }
            if (j == 2 || j == 3) { Y = Y - random - 1; }
            
            if (X < 0) X = 0;
            
                         
             
            sprintf (buffer,"X : %d", X);
            PrintXY(0, 17,buffer,0);
            sprintf (buffer,"Y : %d", Y);
            PrintXY(50, 17,buffer,0);
        
            ML_display_vram();
        
            //Premier quart
            if (j == 0)
            {
                condition = Y + 1;
                for (Y_2 = Y_2; Y_2 < condition; Y_2++)
                {
        
                    if (X_2  == X + 1) X_2 = X; // X_2 ne dpasse pas X et on continue de "dessiner" le contour tant que Y_2 n'est pas gal  Y
            
                    for (X_2 = X_2; X_2 < X + 1; X_2++)
                    {
                        if (X_2 < 50 && Y_2 < 50) monde1[Y_2][X_2] = 1;
                        if (X_2 > 49 && Y_2 < 50) monde2[Y_2][X_2 - 50] = 1;
                        if (X_2 < 50 && Y_2 > 49) monde3[Y_2 - 50][X_2] = 1;
                        if (X_2 > 49 && Y_2 > 49) monde4[Y_2 - 50][X_2 - 50] = 1;
                    };
                    
                    cote_gauche_X[Y_2 - premier_Y] = X_2 - 1;
                    sprintf (buffer,"X_2 : %d", X_2);
                    PrintXY(0, 57,buffer,0);
                    sprintf (buffer,"Ylst : %d", Y_2 - premier_Y);
                    PrintXY(60, 57,buffer,0);
        
                    ML_display_vram();
                    
                };
            } // if j = 0
            
            
             if (j == 1)
            {
                condition = Y + 1;
                for (Y_2 = Y_2; Y_2 < condition; Y_2++)
                {
        
                    if (X_2  == X - 1) X_2 = X; // X_2 ne dpasse pas X et on continue de "dessiner" le contour tant que Y_2 n'est pas gal  Y
            
                    for (X_2 = X_2; X_2 > X - 1; X_2--)
                    {
                        if (X_2 < 50 && Y_2 < 50) monde1[Y_2][X_2] = 1;
                        if (X_2 > 49 && Y_2 < 50) monde2[Y_2][X_2 - 50] = 1;
                        if (X_2 < 50 && Y_2 > 49) monde3[Y_2 - 50][X_2] = 1;
                        if (X_2 > 49 && Y_2 > 49) monde4[Y_2 - 50][X_2 - 50] = 1;
                    };
                    
                    cote_gauche_X[Y_2 - premier_Y + 1] = X_2 + 1;
                    dernier_Y = Y_2 - premier_Y;
                    sprintf (buffer,"X_2 : %d", X_2);
                    PrintXY(0, 57,buffer,0);
                    sprintf (buffer,"Ylst : %d", Y_2 - premier_Y);
                    PrintXY(60, 57,buffer,0);
        
                    ML_display_vram();
                };
            } // if j = 1
            
            
             if (j == 2)
            {
                condition = Y - 1;
                for (Y_2 = Y_2; Y_2 > condition; Y_2--)
                {
        
                    if (X_2  == X - 1) X_2 = X; // X_2 ne dpasse pas X et on continue de "dessiner" le contour tant que Y_2 n'est pas gal  Y
            
                    for (X_2 = X_2; X_2 > X - 1; X_2--)
                    {
                        if (X_2 < 50 && Y_2 < 50) monde1[Y_2][X_2] = 1;
                        if (X_2 > 49 && Y_2 < 50) monde2[Y_2][X_2 - 50] = 1;
                        if (X_2 < 50 && Y_2 > 49) monde3[Y_2 - 50][X_2] = 1;
                        if (X_2 > 49 && Y_2 > 49) monde4[Y_2 - 50][X_2 - 50] = 1;
                    };
                    
                    cote_droit_X[Y_2 - premier_Y] = X_2 + 1;
                    sprintf (buffer,"X_2 : %d", X_2);
                    PrintXY(0, 57,buffer,0);
                    sprintf (buffer,"Ylst : %d", Y_2 - premier_Y);
                    PrintXY(60, 57,buffer,0);
        
                    ML_display_vram();
                    
                };
            } // if j = 2
            
            
             if (j == 3)
            {
                //On finit de "boucler" le continent
                if (i > taille - 2) { X = premier_X; Y = premier_Y; }
                
                if (X > premier_X) X = premier_X;
                if (Y < premier_Y) Y = premier_Y;
                
                condition = Y - 1;
                for (Y_2 = Y_2; Y_2 > condition; Y_2--)
                {
                    
                    if (X_2  == X + 1) X_2 = X; // X_2 ne dpasse pas X et on continue de "dessiner" le contour tant que Y_2 n'est pas gal  Y
            
                    for (X_2 = X_2; X_2 < X + 1; X_2++)
                    {
                        if (X_2 < 50 && Y_2 < 50) monde1[Y_2][X_2] = 1;
                        if (X_2 > 49 && Y_2 < 50) monde2[Y_2][X_2 - 50] = 1;
                        if (X_2 < 50 && Y_2 > 49) monde3[Y_2 - 50][X_2] = 1;
                        if (X_2 > 49 && Y_2 > 49) monde4[Y_2 - 50][X_2 - 50] = 1;
                        
                        sprintf (buffer,"X2 : %d", X_2);
                        PrintXY(0, 37,buffer,0);
                        sprintf (buffer,"Y2 : %d", Y_2);
                        PrintXY(50, 37,buffer,0);
        
                        ML_display_vram();
                       
                    };
                    
                    cote_droit_X[Y_2 - premier_Y] = X_2 - 1;
                    sprintf (buffer,"X_2 : %d", X_2);
                    PrintXY(0, 57,buffer,0);
                    sprintf (buffer,"Ylst : %d", Y_2 - premier_Y);
                    PrintXY(60, 57,buffer,0);
        
                    ML_display_vram();
                };
            } // if j = 3
            
        }; // for i
        
             
    } ; // for j

Y--;

Y = premier_Y;
    
    for (Y_pour_liste = 0; Y_pour_liste < dernier_Y +1; Y_pour_liste++)
    {
        
        
        X = cote_gauche_X[Y_pour_liste] - 1;

        
        X_2 = 0;
        
        while (X_2 == 0 && X > -1)
        {
            
            X--;
             
             if (X == cote_droit_X[Y_pour_liste]) X_2 = 1;
            
        }
        
        X = cote_gauche_X[Y_pour_liste] - 1;
        
        while (X_2 == 1 && X > -1)
        {
           
            if (X_2 == 1)
            {
                if (X < 50 && Y < 50) monde1[Y][X] = 2;
                if (X > 49 && Y < 50) monde2[Y][X - 50] = 2;
                if (X < 50 && Y > 49) monde3[Y - 50][X] = 2;
                if (X > 49 && Y > 49) monde4[Y - 50][X - 50] = 2;
            }
            
            X--;
            
            ML_clear_vram();
            sprintf (buffer,"X : %d", X);
            PrintXY(0, 37,buffer,0);
            sprintf (buffer,"Y : %d", Y);
            PrintXY(50, 37,buffer,0);
            i = monde1[Y][X + 1]; //La tile gnre
            sprintf (buffer,"tile : %d", i);
            PrintXY(0, 0,buffer,0);
        
             ML_display_vram();
             
             if (X == cote_droit_X[Y_pour_liste]) X_2 = 0;
            
        }
        
        Y ++;
        
    };
    
    }; //fin de la cration de "nombre_de_continent" continents
        
    return 0;
 }
 
 
 
 
 
 
 
 
 
 
 
 
 /****************************************/
/*                                                               */
/*    Fonction d'affichage de la map    */
/*                                                               */
/****************************************/
 
 int affichage_monde(char monde1[][50], char monde2[][50], char monde3[][50], char monde4[][50], int X_bateau, int Y_bateau)
 {
    int X; //X des blocs
    int Y; //Y des blocs
    int X_tab; //X des blocs dans le tableau corespondant
    int Y_tab; //Y des blocs dans le tableau corespondant
    int A; //coord X de l'affichage
    int B; //coord Y de l'affichage
    char type_de_bloc; //Le bloc  afficher
    //Les sprites des blocs
    const unsigned char bloc[2][4] = {
    {0xff, 0xff, 0xff, 0xff, },
    {0xff, 0x9f, 0x9f, 0xff, }, };
    int chunk;
    int chunk_X;
    int chunk_Y;
    int entier;
    int decimal;
    char buffer[50];
    
    B = 0;
    for (Y = Y_bateau - 7; Y < Y_bateau + 9; Y++)
    { 
        A = 0;
        
        for (X = X_bateau - 15; X < X_bateau + 17; X++)
        {
            if ( X > -1 && Y > -1)
            {
                chunk_X = X / 50;
                entier = chunk_X / 2;
                entier = entier * 10;
                decimal = chunk_X * 10;
                decimal = decimal / 2;
                if (entier == decimal) chunk_X == 0;
                else chunk_X == 1;
                
                chunk_Y = Y / 50;
                entier = chunk_Y / 2;
                entier = entier * 10;
                decimal = chunk_Y * 10;
                decimal = decimal / 2;
                if (entier == decimal) chunk_Y == 0;
                else chunk_Y == 1;
                
                if (chunk_X + chunk_Y == 0) chunk = 1;
                if (chunk_X + chunk_Y == 1)
                {
                    if (chunk_X == 1) chunk = 2;
                    if (chunk_X == 0) chunk = 3;
                }
                if (chunk_X + chunk_Y == 2) chunk = 4;
                
                X_tab = X - 50 * chunk_X;
                Y_tab = Y - 50 * chunk_Y;
                
                if (chunk == 1) type_de_bloc = monde1[Y_tab][X_tab];
                if (chunk == 2) type_de_bloc = monde2[Y_tab][X_tab];
                if (chunk == 3) type_de_bloc = monde3[Y_tab][X_tab];
                if (chunk == 4) type_de_bloc = monde4[Y_tab][X_tab];
                if (type_de_bloc != 0 && type_de_bloc != 2) ML_bmp_or_cl(bloc[type_de_bloc - 1], A*4, B*4, 4, 4);
            }
            
            A++;
        };
        
        B++;        
    };
    
    
    return 0;
 }









/****************************************/
/*                                                               */
/*             Fonction principale                */
/*                                                               */
/****************************************/

int AddIn_main(int isAppli, unsigned short OptionNum)
{


// ======= INITIALISATION DU JEU ======= //

    //Sprites du bateau
    const unsigned char bateau_1_3[2][16] = {
    {0x18, 0x3c, 0x66, 0x42, 0xff, 0x99, 0xbd, 0xdb, 0x99, 0x7e, 0x5a, 0x42, 0x42, 0x66, 0x7e, 0x3c, },
    {0x7e, 0x66, 0x42, 0xff, 0xbd, 0xc3, 0xbd, 0x81, 0x42, 0x7e, 0x5a, 0x42, 0x66, 0x7e, 0x3c, 0x18, }, };
    
    const unsigned char bateau_2_4[2][30] = {
    {0x1, 0x0, 0x1, 0x80, 0x1, 0x40, 0x1, 0x40, 0x1, 0x20, 0x1, 0x20, 0x1, 0x20, 0x1, 0x60, 0x7f, 0x78, 0xff, 0xfe, 0xc1, 0x7, 0xe0, 0xf, 0x9f, 0xf2, 0x80, 0x4, 0x7f, 0xf8, },
    {0x0, 0x80, 0x1, 0x80, 0x2, 0x80, 0x2, 0x80, 0x4, 0x80, 0x4, 0x80, 0x4, 0x80, 0x6, 0x80, 0x1e, 0xfe, 0x7f, 0xff, 0xe0, 0x83, 0xf0, 0x7, 0x4f, 0xf9, 0x20, 0x1, 0x1f, 0xfe, }, };
    

    char buffer[50]; //Tableau pour la conversion int to char
    unsigned int key; //Valeur du GetKey
    int random; //Variable d'initialisation de l'alatoire
    int delay; //Temps d'attente du GetKey
    int delay_touche = 0; //Temps de rptition d'appui de la mme touche
    int touche; //La touche appuye
    int appui; //Vrifie si une touche est appuye
    int bloc_collision; //Variable qui dtermine avec quel bloc le bateau entre en collision
    int collision; //indique si le bateau peut avancer ou non

    //coordonnes du bateau
    int X_bateau = 16;
    int Y_bateau = 8;
    //sauvegarde des coordonnes du bateau
    int X_bateau_2 = 16;
    int Y_bateau_2 = 8;
    
    //Vers ou pointe l'avant du bateau
    int direction_bateau = 1;
    //Sauvegarde de la direction du bateau
    int direction_bateau_2 = 1;
    
    //coordonnes des pirates
    int X_pirate;
    int Y_pirate;
    //sauvegarde des coordonnes des pirates
    int X_pirate_2;
    int Y_pirate_2;
    
    //Vers ou pointe l'avant du bateau des pirates
    int direction_pirate = 1;
    //Sauvegarde de la direction du bateau des pirates
    int direction_pirate_2 = 1;
    
    //X et Y pour les collisions
    int X;
    int Y;
    
    //Le tableau qui va contenir le monde
    char monde1[50][50] = {{0}};
    char monde2[50][50] = {{0}};
    char monde3[50][50] = {{0}};
    char monde4[50][50] = {{0}};

    //gnration du monde
    generation_monde(monde1, monde2, monde3, monde4);

  
  
  // ======= MOTEUR DU JEU ======= //

    while (IsKeyDown(47) == 0)
    {
    
    
        // ~~~~~~ affichage ~~~~~~ //
        
        ML_clear_vram();
        
        affichage_monde(monde1, monde2, monde3, monde4, X_bateau, Y_bateau);
        if (direction_bateau == 1 || direction_bateau == 3) ML_bmp_or(bateau_1_3[(direction_bateau-1)/2], 60, 24, 8, 16);
        if (direction_bateau == 2 || direction_bateau == 4) ML_bmp_or(bateau_2_4[direction_bateau/2-1], 56, 25, 16, 15);
        
        ML_display_vram();
        
        
        // ~~~~~~ Sauvegarde des coorodonnes ~~~~~~ //
        
        X_bateau_2 = X_bateau;
        Y_bateau_2 = Y_bateau;
        
        // ~~~~~~ GetKey ~~~~~~ //
        
        delay = 0; //On remet le temps de boucle  0
        appui = 0;
       
        while (delay < 16 && appui == 0)
        {
            if (IsKeyDown(28) == 1 || IsKeyDown(27) == 1 || IsKeyDown(38) == 1 || IsKeyDown(37) == 1) appui = 1;
            else appui = 0;
  
            Sleep(1);
            delay++;
        }
        delay_touche = delay_touche + delay;
        if (delay_touche > 15) delay_touche = 15;
        
        
        
        // ~~~~~~ Gestion de la touche presse ~~~~~~ //
        
        if (IsKeyDown(28) == 1 && touche != 28 || IsKeyDown(28) == 1 && delay_touche == 15)
        {
            touche = 28;
            delay_touche = 0;
            if (direction_bateau == 1) Y_bateau--;
            else direction_bateau = 1;
        }
        
        if (IsKeyDown(27) == 1 && touche != 27 || IsKeyDown(27) == 1 && delay_touche == 15)
        {
            touche = 27;
            delay_touche = 0;
            if (direction_bateau == 2) X_bateau++;
            else direction_bateau = 2;
        }
        
        if (IsKeyDown(37) == 1 && touche != 37 || IsKeyDown(37) == 1 && delay_touche == 15)
        {
            touche = 37;
            delay_touche = 0;
            if (direction_bateau == 3) Y_bateau++;
            else direction_bateau = 3;
        }
        
        if (IsKeyDown(38) == 1 && touche != 38 || IsKeyDown(38) == 1 && delay_touche == 15)
        {
            touche = 38;
            delay_touche = 0;
            if (direction_bateau == 4) X_bateau--;
            else direction_bateau = 4;
        }
        
        
        
        // ~~~~~~ conditions pour ne pas dpasser la limite de la map ~~~~~~ //
        
        if (X_bateau > 100) X_bateau = 100;
        if (X_bateau < 0) X_bateau = 0;
        if (Y_bateau > 100) Y_bateau = 100;
        if (Y_bateau < 0) Y_bateau = 0;
        
        
        
        // ~~~~~~ collisions ~~~~~~ //
        
        bloc_collision = 0;
        collision = 0;
        
        for (Y = Y_bateau - 1; Y < Y_bateau + 3; Y++)
        {
            for (X = X_bateau - 1; X < X_bateau + 3; X++)
            {
                if (X < 50 && Y < 50 && monde1[Y][X] != 0) bloc_collision = monde1[Y][X];
                if (X > 49 && Y < 50 && monde2[Y][X - 50] != 0) bloc_collision = monde2[Y][X - 50];
                if (X < 50 && Y > 49 && monde3[Y - 50][X] != 0) bloc_collision = monde3[Y - 50][X];
                if (X > 49 && Y > 49 && monde4[Y - 50][X - 50] != 0) bloc_collision = monde4[Y - 50][X - 50];
                
                if (bloc_collision > 0) collision = 1;
                if (bloc_collision < 0)
                {
                    switch (bloc_collision)
                    {
                        case -1 : bloc_collision = -1; //test
                    }
                }
            };
        };
        
        if (collision == 1) { X_bateau = X_bateau_2;   Y_bateau = Y_bateau_2; }

    }
    
   
   
    // ======= FIN DU JEU ======= //
    
    GetKey(&key);
    
    return 1;
}

