#include "fxlib.h"
#include "math.h"
#include "stdlib.h"
#include "string.h"
#include "stdio.h"
#include "memory.h"
#include "usefull.h"
#include "MonochromeLib.h"
#include "input.h"
#include "Infos.h"

void draw_selection(int Menu, int Selection)
{
	const unsigned char Horizontal_Menu[] = {2, 2, 2, 1, 2};
	const unsigned char Vertical_Menu[] = {1, 2, 1, 2, 1};
	int X_Selection = Selection%Horizontal_Menu[Menu];
	int Y_Selection = Selection/Horizontal_Menu[Menu];

	int X1, Y1, X2, Y2;

	switch (Menu)
	{
		case 0 : 
		{
			X1 = 6 + X_Selection*29;
			X2 = X1 + 22;
			Y1 = 2;
			Y2 = Y1 + 6;
			break;
		}
		case 1 : 
		{
			X1 = 2 + X_Selection*32;
			X2 = X1 + 26;
			Y1 = 28 + Y_Selection*8;
			Y2 = Y1 + 6;
			break;
		}
		case 2 : 
		{
			X1 = 5 + X_Selection*28;
			X2 = X1 + 26;
			Y1 = 37;
			Y2 = Y1 + 6;
			break;
		}
		case 3 : 
		{
			X1 = 107;
			X2 = X1 + 17;
			Y1 = 46 + Y_Selection*7;
			Y2 = Y1 + 6;
			break;
		}
		case 4 : 
		{
			X1 = 2 + X_Selection*32;
			X2 = X1 + 26;
			Y1 = 34;
			Y2 = Y1 + 6;
			break;
		}
	}

	ML_rectangle(X1, Y1, X2, Y2, 0, 0, 2);	//Dessin d'un rectangle en négatif sur la sélection
	ML_pixel(X1, Y1, 0);
	ML_pixel(X1, Y2, 0);
	ML_pixel(X2, Y1, 0);
	ML_pixel(X2, Y2, 0);
}

void draw_number(int Number, int X_Number, int Y_Number, Type_Color_Number Color_Number, Type_Range_Number Range_Number)
{
	const unsigned char Chiffres[]={
		0xff, 0xbf, 0xbf, 0xbf, 0xff,
		0x5f, 0xdf, 0x5f, 0x5f, 0xff,
		0xff, 0x3f, 0xff, 0x9f, 0xff,
		0xff, 0x3f, 0x7f, 0x3f, 0xff,
		0xbf, 0xbf, 0xff, 0x3f, 0x3f,
		0xff, 0x9f, 0xff, 0x3f, 0xff,
		0xff, 0x9f, 0xff, 0xbf, 0xff,
		0xff, 0x3f, 0x7f, 0x3f, 0x3f,
		0xff, 0xbf, 0xff, 0xbf, 0xff,
		0xff, 0xbf, 0xff, 0x3f, 0xff};

	const unsigned char Gap[] = {WIDTH_DIGIT+1, (WIDTH_DIGIT+1)/2, 0};

	int i;

	if(!Number)
	{
		if(Color_Number >= BLACK)ML_bmp_or(Chiffres, X_Number, Y_Number, WIDTH_DIGIT, 5);			//Dessin de zéro en BLACK
		if(Color_Number == BLACK_WHITE)ML_bmp_and_cl(Chiffres, X_Number, Y_Number, WIDTH_DIGIT, 5);	//Dessin de l'intérieur du zéro
		if(Color_Number == WHITE)ML_bmp_xor(Chiffres, X_Number, Y_Number, WIDTH_DIGIT, 5);			//Dessin de zéro en WHITE
	}
	else
	{
		for(i = X_Number+Gap[Range_Number]*(int)(log10(Number)); Number; i -= WIDTH_DIGIT+1)	//Boucle qui récupère les coordonnée du chiffre à afficher
		{
			if(Color_Number >= BLACK)ML_bmp_or(Chiffres+5*(Number%10), i, Y_Number, WIDTH_DIGIT, HEIGHT_DIGIT);				//Dessin du chiffre en BLACK
			if(Color_Number == BLACK_WHITE)ML_bmp_and_cl(Chiffres+5*(Number%10), i, Y_Number, WIDTH_DIGIT, HEIGHT_DIGIT);	//Dessin de l'intérieur du chiffre
			if(Color_Number == WHITE)ML_bmp_xor(Chiffres+5*(Number%10), i, Y_Number, WIDTH_DIGIT, HEIGHT_DIGIT);			//Dessin du chiffre en WHITE
			Number /= 10;																											//Changement du chiffre à afficher (dans le Number)
		}
	}
}

void draw_boat(unsigned char Type_Boat, int Pv, int X_Boat, int Y_Boat)
{
	const unsigned char Or_Type_Boats[28][64] = {
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x30, 0x38, 0x3c, 0x3e, 0x3f, 0x7f, 0xff, 0x7e, 0xff, 0x7e, },	//Bateau SMALL 1 a
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x30, 0x38, 0x38, 0x3c, 0x3c, 0x7e, 0xff, 0x7e, 0xff, 0x7e, },	//______________ b
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xc, 0x1f, 0x1c, 0x7f, 0xff, 0x7f, 0xfe, 0x3c, },		//____________ 2 a
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xc, 0x1e, 0x1f, 0x7e, 0xff, 0x7f, 0xfe, 0x3c, },		//______________ b
		
		{0x0, 0x0, 0x0, 0x0, 0x1, 0x40, 0xd, 0xe0, 0xf, 0xf0, 0xf, 0xf0, 0x7, 0xf0, 0x7, 0xf0, 0xe7, 0xf0, 0xff, 0xe0, 0xff, 0xfc, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xfe, 0x7f, 0xfc, 0x3f, 0xf8, },
		{0x0, 0x0, 0x0, 0x0, 0x1, 0x60, 0xd, 0xf0, 0xf, 0xf8, 0x7, 0xf8, 0x3, 0xf8, 0x3, 0xf8, 0xe3, 0xf0, 0xff, 0xe0, 0xff, 0xfc, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xfe, 0x7f, 0xfc, 0x3f, 0xf8, },
		{0x0, 0x0, 0x0, 0x0, 0x1, 0x40, 0x5, 0xe0, 0xf, 0xf0, 0xf, 0xf0, 0x7, 0xf0, 0x7, 0xf0, 0x27, 0xe0, 0x7f, 0x80, 0xff, 0xfc, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xfc, 0x7f, 0xf8, 0x3f, 0xf0, },
		{0x0, 0x0, 0x0, 0x0, 0x1, 0x60, 0x5, 0xf0, 0xf, 0xf8, 0x7, 0xf8, 0x3, 0xf8, 0x3, 0xf0, 0x27, 0xe0, 0x7f, 0x80, 0xff, 0xfc, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xfc, 0x7f, 0xf8, 0x3f, 0xf0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x1e, 0x0, 0x7f, 0x0, 0x3f, 0x80, 0x1f, 0xc0, 0xf, 0xc0, 0x1f, 0xc0, 0x7f, 0xf0, 0x7f, 0xf8, 0xff, 0xfc, 0xff, 0xfc, 0x3f, 0xf8, 0x1f, 0xf0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x1f, 0x0, 0x7f, 0x80, 0x3f, 0xc0, 0xf, 0xe0, 0xf, 0xe0, 0x1f, 0xc0, 0x7f, 0xf0, 0x7f, 0xf8, 0xff, 0xfc, 0xff, 0xfc, 0x3f, 0xf8, 0x1f, 0xf0, },

		{0x0, 0x6c, 0x0, 0x3, 0x7c, 0x0, 0x3, 0xfe, 0x0, 0x1, 0xfe, 0x0, 0x1, 0xfe, 0x0, 0x1, 0xfe, 0x0, 0x1, 0xfe, 0x0, 0x1, 0xfe, 0x0, 0xf1, 0xfc, 0x0, 0xff, 0xf8, 0x0, 0xff, 0xff, 0xe0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xff, 0xff, 0xf0, 0xff, 0xff, 0xe0, 0x3f, 0xff, 0x80, },
		{0x0, 0x6c, 0x0, 0x3, 0x7c, 0x0, 0x3, 0xfe, 0x0, 0x1, 0xff, 0x0, 0x0, 0xff, 0x0, 0x0, 0xff, 0x0, 0x0, 0xff, 0x0, 0x0, 0xfe, 0x0, 0xf1, 0xfc, 0x0, 0xff, 0xf8, 0x0, 0xff, 0xff, 0xe0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xff, 0xff, 0xf0, 0xff, 0xff, 0xe0, 0x3f, 0xff, 0x80, },
		{0x0, 0x60, 0x0, 0x0, 0x78, 0x0, 0x3, 0xfc, 0x0, 0x3, 0xfc, 0x0, 0x1, 0xfe, 0x0, 0x0, 0xfe, 0x0, 0x0, 0xfe, 0x0, 0x1, 0xfe, 0x0, 0x31, 0xfc, 0x0, 0x7f, 0xf8, 0x0, 0xff, 0xff, 0xe0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0xff, 0xff, 0xc0, 0xff, 0xff, 0x0, 0x3f, 0xfe, 0x0, },
		{0x0, 0x60, 0x0, 0x0, 0x78, 0x0, 0x3, 0xfc, 0x0, 0x1, 0xfe, 0x0, 0x0, 0xff, 0x0, 0x0, 0x7f, 0x0, 0x0, 0x7f, 0x0, 0x0, 0xfe, 0x0, 0x31, 0xfc, 0x0, 0x7f, 0xf8, 0x0, 0xff, 0xff, 0xe0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0xff, 0xff, 0xc0, 0xff, 0xff, 0x0, 0x3f, 0xfe, 0x0, },
		{0x0, 0x20, 0x0, 0x0, 0x38, 0x0, 0x0, 0x7c, 0x0, 0x3, 0xfc, 0x0, 0x1, 0xfe, 0x0, 0x0, 0xfe, 0x0, 0x0, 0xfe, 0x0, 0x1, 0xfc, 0x0, 0x21, 0xf0, 0x0, 0x77, 0xe0, 0x0, 0xff, 0xff, 0x0, 0xff, 0xff, 0xbc, 0xff, 0xff, 0xf0, 0x7f, 0xff, 0xc0, 0x3f, 0xff, 0x0, 0xf, 0xfc, 0x0, },
		{0x0, 0x20, 0x0, 0x0, 0x38, 0x0, 0x0, 0x7c, 0x0, 0x3, 0xfe, 0x0, 0x1, 0xfe, 0x0, 0x0, 0x7e, 0x0, 0x0, 0x7e, 0x0, 0x0, 0xfe, 0x0, 0x21, 0xfc, 0x0, 0x77, 0xf0, 0x0, 0xff, 0xff, 0x0, 0xff, 0xff, 0xbc, 0xff, 0xff, 0xf0, 0x7f, 0xff, 0xc0, 0x3f, 0xff, 0x0, 0xf, 0xfc, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc, 0x0, 0x0, 0xf, 0x0, 0x0, 0x7, 0x80, 0x0, 0x1f, 0xe0, 0x0, 0xf, 0xf0, 0x0, 0x1f, 0xf0, 0x0, 0xf, 0xe0, 0x0, 0x1f, 0xc0, 0x0, 0x3f, 0xfc, 0x0, 0x7f, 0xfe, 0x0, 0x7f, 0xff, 0xf0, 0x7f, 0xff, 0xc0, 0x1f, 0xff, 0x0, 0x3, 0xfe, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc, 0x0, 0x0, 0xf, 0x80, 0x0, 0x7, 0xe0, 0x0, 0xf, 0xf0, 0x0, 0x7, 0xf0, 0x0, 0x1f, 0xf0, 0x0, 0x7, 0xf0, 0x0, 0x1f, 0xe0, 0x0, 0x3f, 0xfc, 0x0, 0x7f, 0xfe, 0x0, 0x7f, 0xff, 0xf0, 0x7f, 0xff, 0xc0, 0x1f, 0xff, 0x0, 0x3, 0xfe, 0x0, },

		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x10, 0x10, 0x0, 0x3e, 0x3e, 0x3e, 0x0, 0x3f, 0x3f, 0x3f, 0x0, 0x1f, 0x1f, 0x1f, 0x80, 0xf, 0x8f, 0x8f, 0x80, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x7f, 0xff, 0xff, 0xfc, 0x3f, 0xff, 0xff, 0xf8, 0x1f, 0xff, 0xff, 0xf0, 0xf, 0xff, 0xff, 0xe0, },
		{0x0, 0x0, 0x0, 0x0, 0x60, 0x60, 0x60, 0x0, 0x70, 0x70, 0x70, 0x0, 0x7e, 0x7e, 0x7e, 0x0, 0x3f, 0x3f, 0x3f, 0x0, 0x1f, 0x1f, 0x1f, 0x80, 0xf, 0x8f, 0x8f, 0x80, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x7f, 0xff, 0xff, 0xfc, 0x3f, 0xff, 0xff, 0xf8, 0x1f, 0xff, 0xff, 0xf0, 0xf, 0xff, 0xff, 0xe0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x10, 0x0, 0x0, 0x3e, 0x3e, 0x0, 0x4, 0x3f, 0x3f, 0x0, 0x6, 0x9f, 0x1f, 0x80, 0xf, 0x8f, 0x8f, 0x80, 0x3f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xfe, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xf0, 0x3f, 0xff, 0xff, 0xe0, 0x1f, 0xff, 0xff, 0xc0, 0xf, 0xff, 0xff, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x60, 0x60, 0x0, 0x0, 0x70, 0x70, 0x0, 0x0, 0x7e, 0x7e, 0x0, 0x4, 0x3f, 0x3f, 0x0, 0x6, 0x9f, 0x1f, 0x80, 0xf, 0x8f, 0x8f, 0x80, 0x3f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xfe, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xf0, 0x3f, 0xff, 0xff, 0xe0, 0x1f, 0xff, 0xff, 0xc0, 0xf, 0xff, 0xff, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x18, 0x38, 0x0, 0x0, 0x3e, 0x1c, 0x0, 0x4, 0x3f, 0xc, 0x0, 0x6, 0x9f, 0x7, 0x0, 0xf, 0x8f, 0x8f, 0x80, 0x3f, 0xff, 0xff, 0xe0, 0x7f, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xf8, 0xff, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xf0, 0x3f, 0xff, 0xff, 0xe0, 0x1f, 0xff, 0xff, 0xc0, 0xf, 0xf9, 0xfe, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x30, 0x0, 0x0, 0x18, 0x3c, 0x0, 0x0, 0x3e, 0x1c, 0x0, 0x4, 0x3f, 0x4, 0x0, 0x6, 0x9f, 0x3, 0x0, 0xf, 0x8f, 0x8f, 0x80, 0x3f, 0xff, 0xff, 0xe0, 0x7f, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xf8, 0xff, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xf0, 0x3f, 0xff, 0xff, 0xe0, 0x1f, 0xff, 0xff, 0xc0, 0xf, 0xf9, 0xfe, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x0, 0x3e, 0x0, 0x0, 0x4, 0x3f, 0x0, 0x0, 0x6, 0x9f, 0x8, 0x0, 0xf, 0x8f, 0x8e, 0x80, 0xf, 0xef, 0xff, 0xc0, 0x3f, 0xff, 0xff, 0xe0, 0x7f, 0xff, 0xff, 0xf0, 0x7f, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xf0, 0x3f, 0xff, 0xff, 0xf0, 0x1f, 0xff, 0xff, 0xe0, 0x1f, 0xff, 0xff, 0x80, 0xf, 0xf9, 0xfe, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x60, 0x0, 0x0, 0x0, 0x70, 0x0, 0x0, 0x0, 0x7e, 0x0, 0x0, 0x4, 0x3f, 0x0, 0x0, 0x6, 0x9f, 0x8, 0x0, 0xf, 0x8f, 0x8e, 0x80, 0xf, 0xef, 0xff, 0xc0, 0x3f, 0xff, 0xff, 0xe0, 0x7f, 0xff, 0xff, 0xf0, 0x7f, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xf0, 0x3f, 0xff, 0xff, 0xf0, 0x1f, 0xff, 0xff, 0xe0, 0x1f, 0xff, 0xff, 0x80, 0xf, 0xf9, 0xfe, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x60, 0x0, 0x0, 0x0, 0xe0, 0x0, 0x0, 0x0, 0x70, 0x0, 0x0, 0x2, 0x30, 0x0, 0x0, 0xf, 0x9c, 0x0, 0x0, 0xf, 0xff, 0xc0, 0x0, 0x1f, 0xff, 0xee, 0x0, 0x1f, 0xff, 0xff, 0x80, 0x3f, 0xff, 0xff, 0xc0, 0x3f, 0xff, 0xff, 0xc0, 0x3f, 0xff, 0xff, 0x80, 0x1f, 0xff, 0xff, 0x0, 0x7, 0xff, 0xfe, 0x0, 0x3, 0xf8, 0x78, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc0, 0x0, 0x0, 0x0, 0xf0, 0x0, 0x0, 0x0, 0x70, 0x0, 0x0, 0x2, 0x10, 0x0, 0x0, 0xf, 0x8c, 0x0, 0x0, 0xf, 0xff, 0xc0, 0x0, 0x1f, 0xff, 0xee, 0x0, 0x1f, 0xff, 0xff, 0x80, 0x3f, 0xff, 0xff, 0xc0, 0x3f, 0xff, 0xff, 0xc0, 0x3f, 0xff, 0xff, 0x80, 0x1f, 0xff, 0xff, 0x0, 0x7, 0xff, 0xfe, 0x0, 0x3, 0xf8, 0x78, 0x0, }};
	const unsigned char Xor_Type_Boats[28][64] = {
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x18, 0x1c, 0x1e, 0x0, 0x5e, 0x8, 0x7e, 0x0, },	//Bateau SMALL 1 a
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x10, 0x18, 0x18, 0xc, 0x54, 0x8, 0x7e, 0x0, },	//______________ b
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc, 0x8, 0x1c, 0x40, 0xc, 0x38, 0x0, },		//____________ 2 a
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0xc, 0x18, 0x44, 0xc, 0x38, 0x0, },		//______________ b

		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x5, 0xe0, 0x7, 0x60, 0x3, 0x60, 0x3, 0x60, 0x2, 0xe0, 0x67, 0x80, 0x60, 0x0, 0x6e, 0x78, 0xf, 0xfc, 0x60, 0x0, 0x3f, 0xf0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x60, 0x5, 0xf0, 0x3, 0x70, 0x1, 0xb0, 0x1, 0xb0, 0x1, 0x60, 0x63, 0x80, 0x60, 0x0, 0x6e, 0x78, 0xf, 0xfc, 0x60, 0x0, 0x3f, 0xf0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x5, 0xa0, 0x7, 0x60, 0x3, 0x40, 0x3, 0x20, 0x2, 0x80, 0x27, 0x0, 0x20, 0x0, 0x6e, 0x70, 0xf, 0xe8, 0x60, 0x10, 0x3f, 0xd0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x60, 0x5, 0xd0, 0x1, 0x30, 0x1, 0x90, 0x1, 0x20, 0x3, 0x80, 0x27, 0x0, 0x20, 0x0, 0x6e, 0x70, 0xf, 0xe8, 0x60, 0x10, 0x3f, 0xd0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x16, 0x0, 0x1d, 0x0, 0x2, 0x80, 0x5, 0x80, 0xf, 0x0, 0x0, 0x0, 0x2e, 0x40, 0x4f, 0xa8, 0x20, 0x50, 0x17, 0x90, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x17, 0x0, 0xc, 0x80, 0x3, 0x40, 0x2, 0xc0, 0x7, 0x0, 0x0, 0x0, 0x2e, 0x40, 0x4f, 0xa8, 0x20, 0x50, 0x17, 0x90, 0x0, 0x0, },
		
		{0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x1, 0x3c, 0x0, 0x0, 0xf4, 0x0, 0x0, 0xd4, 0x0, 0x0, 0xd4, 0x0, 0x0, 0xdc, 0x0, 0x0, 0xbc, 0x0, 0x0, 0xf8, 0x0, 0x61, 0x80, 0x0, 0x6c, 0x0, 0x0, 0xd, 0x9f, 0xc0, 0x61, 0xff, 0x20, 0x1c, 0x0, 0xc0, 0x3, 0xff, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x1, 0x3c, 0x0, 0x0, 0xf6, 0x0, 0x0, 0x5a, 0x0, 0x0, 0x6a, 0x0, 0x0, 0x6e, 0x0, 0x0, 0x5c, 0x0, 0x0, 0xf8, 0x0, 0x61, 0x80, 0x0, 0x6c, 0x0, 0x0, 0xd, 0x9f, 0xc0, 0x61, 0xff, 0x20, 0x1c, 0x0, 0xc0, 0x3, 0xff, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x28, 0x0, 0x1, 0xf0, 0x0, 0x0, 0xd0, 0x0, 0x0, 0x54, 0x0, 0x0, 0x5c, 0x0, 0x0, 0xbc, 0x0, 0x0, 0xf8, 0x0, 0x21, 0x0, 0x0, 0x74, 0x0, 0x0, 0xd, 0x9f, 0x40, 0x51, 0xfa, 0x80, 0x3c, 0x5, 0x0, 0x3, 0xec, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x28, 0x0, 0x0, 0xf4, 0x0, 0x0, 0x5a, 0x0, 0x0, 0x2a, 0x0, 0x0, 0x2e, 0x0, 0x0, 0x5c, 0x0, 0x0, 0xf8, 0x0, 0x21, 0x0, 0x0, 0x74, 0x0, 0x0, 0xd, 0x9f, 0x40, 0x51, 0xfa, 0x80, 0x3c, 0x5, 0x0, 0x3, 0xec, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x28, 0x0, 0x0, 0x70, 0x0, 0x0, 0xd0, 0x0, 0x0, 0x54, 0x0, 0x0, 0x5c, 0x0, 0x0, 0xb0, 0x0, 0x0, 0xe0, 0x0, 0x21, 0x0, 0x0, 0x54, 0x0, 0x0, 0xd, 0x9f, 0x0, 0x51, 0xf8, 0x80, 0x1c, 0x6, 0x0, 0x3, 0xe8, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x28, 0x0, 0x0, 0x74, 0x0, 0x0, 0x58, 0x0, 0x0, 0x28, 0x0, 0x0, 0x2c, 0x0, 0x0, 0x5c, 0x0, 0x0, 0xf0, 0x0, 0x21, 0x0, 0x0, 0x54, 0x0, 0x0, 0xd, 0x9f, 0x0, 0x51, 0xf8, 0x80, 0x1c, 0x6, 0x0, 0x3, 0xe8, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x4, 0x80, 0x0, 0x7, 0xe0, 0x0, 0xa, 0x80, 0x0, 0x5, 0x80, 0x0, 0x3, 0x0, 0x0, 0x18, 0x0, 0x0, 0x5, 0x9c, 0x0, 0x2a, 0xea, 0x0, 0x4, 0x15, 0x0, 0x1, 0xec, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0xe0, 0x0, 0x3, 0xa0, 0x0, 0x4, 0xa0, 0x0, 0x1b, 0xc0, 0x0, 0x5, 0x0, 0x0, 0x18, 0x0, 0x0, 0x5, 0x9c, 0x0, 0x2a, 0xea, 0x0, 0x4, 0x15, 0x0, 0x1, 0xec, 0x0, 0x0, 0x0, 0x0, },

		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x10, 0x10, 0x0, 0x18, 0x18, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x1, 0x1, 0x0, 0x3, 0x83, 0x83, 0x80, 0x79, 0xb9, 0xb9, 0xb8, 0x7c, 0x7c, 0x7c, 0x7c, 0x7f, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x1a, 0xaa, 0xaa, 0xb0, 0xd, 0x55, 0x55, 0x60, 0x7, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x20, 0x20, 0x0, 0x10, 0x10, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x1, 0x1, 0x0, 0x3, 0x83, 0x83, 0x80, 0x79, 0xb9, 0xb9, 0xb8, 0x7c, 0x7c, 0x7c, 0x7c, 0x7f, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x1a, 0xaa, 0xaa, 0xb0, 0xd, 0x55, 0x55, 0x60, 0x7, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x10, 0x0, 0x0, 0x18, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x1, 0x0, 0x2, 0x83, 0x83, 0x80, 0x19, 0xb9, 0xb9, 0xb8, 0x2c, 0x7c, 0x7c, 0x44, 0x5f, 0xff, 0xff, 0x98, 0x0, 0x0, 0x0, 0x40, 0x1a, 0xaa, 0xaa, 0xa0, 0xd, 0x55, 0x54, 0xc0, 0x7, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x20, 0x0, 0x0, 0x10, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x1, 0x0, 0x2, 0x83, 0x83, 0x80, 0x19, 0xb9, 0xb9, 0xb8, 0x2c, 0x7c, 0x7c, 0x44, 0x5f, 0xff, 0xff, 0x98, 0x0, 0x0, 0x0, 0x40, 0x1a, 0xaa, 0xaa, 0xa0, 0xd, 0x55, 0x54, 0xc0, 0x7, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x1, 0x0, 0x2, 0x83, 0x83, 0x80, 0x19, 0xb9, 0xb9, 0xa0, 0x2c, 0x7c, 0x7c, 0x40, 0x57, 0xff, 0xff, 0x98, 0x18, 0x0, 0x0, 0x40, 0x6, 0xa2, 0xab, 0x20, 0xd, 0x4d, 0x54, 0xc0, 0x7, 0xe9, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x1, 0x0, 0x2, 0x83, 0x83, 0x80, 0x19, 0xb9, 0xb9, 0xa0, 0x2c, 0x7c, 0x7c, 0x40, 0x57, 0xff, 0xff, 0x98, 0x18, 0x0, 0x0, 0x40, 0x6, 0xa2, 0xab, 0x20, 0xd, 0x4d, 0x54, 0xc0, 0x7, 0xe9, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x2, 0x83, 0x82, 0x80, 0x1, 0xa1, 0xb9, 0x80, 0x34, 0x58, 0x7c, 0x40, 0x27, 0xc7, 0xfe, 0x20, 0x18, 0x0, 0x8, 0xe0, 0x12, 0xa2, 0xa4, 0x40, 0x9, 0x5d, 0x59, 0x80, 0x7, 0x98, 0xfa, 0x0, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x2, 0x83, 0x82, 0x80, 0x1, 0xa1, 0xb9, 0x80, 0x34, 0x58, 0x7c, 0x40, 0x27, 0xc7, 0xfe, 0x20, 0x18, 0x0, 0x8, 0xe0, 0x12, 0xa2, 0xa4, 0x40, 0x9, 0x5d, 0x59, 0x80, 0x7, 0x98, 0xfa, 0x0, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x84, 0x0, 0x0, 0x1, 0xa2, 0xc0, 0x0, 0x4, 0x48, 0x4, 0x0, 0x7, 0xc7, 0x1e, 0x0, 0x18, 0x0, 0x8, 0x80, 0x12, 0xa2, 0x24, 0x0, 0x1, 0x5d, 0x52, 0x0, 0x1, 0x98, 0x70, 0x0, 0x0, 0x0, 0x0, 0x0, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x84, 0x0, 0x0, 0x1, 0xa2, 0xc0, 0x0, 0x4, 0x48, 0x4, 0x0, 0x7, 0xc7, 0x1e, 0x0, 0x18, 0x0, 0x8, 0x80, 0x12, 0xa2, 0x24, 0x0, 0x1, 0x5d, 0x52, 0x0, 0x1, 0x98, 0x70, 0x0, 0x0, 0x0, 0x0, 0x0, }};
	const unsigned char Number_Picture_Boat[] = {2, 8, 16 ,26};

	ML_bmp_or_cl(Or_Type_Boats[Number_Picture_Boat[(Type_Boat-1)]-2*((Pv-100)/100)], X_Boat, Y_Boat, Type_Boat*8, 16);
	ML_bmp_xor_cl(Xor_Type_Boats[Number_Picture_Boat[(Type_Boat-1)]-2*((Pv-100)/100)], X_Boat, Y_Boat, Type_Boat*8, 16);
}

void draw_pv_boat(unsigned char Type_Boat, int Pv, int X_Boat, int Y_Boat)
{
	/*
	draw_number(Pv, X_Boat, Y_Boat+21, BLACK_WHITE, LEFT);
	if(Pv > 100)Pv -= 100;
	ML_rectangle(X_Boat+1, Y_Boat+17, X_Boat+8*Type_Boat-2, Y_Boat+19, 1, 1, 1);
	ML_horizontal_line(Y_Boat+18, X_Boat+2, X_Boat+1+Pv/100*4, 2);
	*/
}

void draw_dock(unsigned char *Boats)
{
	const unsigned char Dock_1[]={0x0, 0x1f, 0x0, 0x1f, 0x0, 0x9f, 0x0, 0x1f, 0x3e, 0x1f, 0x3e, 0x1f, 0x22, 0x1f, 0xfa, 0x1f, 0xfe, 0x5f, 0x88, 0x1f, 0xf8, 0x1f, 0x0, 0x1f, 0x1, 0x1f, 0x40, 0x1f, 0x0, 0x1f, 0x0, 0x1f, 0x8, 0x1f, 0x0, 0xf, 0x0, 0x4f, 0x0, 0xf, 0xf0, 0x1f, 0xf0, 0x1f, 0x93, 0xdf, 0xf3, 0xdf, 0x2, 0x5f, 0x3, 0xdf, 0x0, 0x1f, 0x80, 0x1f, 0xc, 0x1f, 0x1e, 0x1f, 0x13, 0x9f, 0x13, 0xdf, 0x16, 0x5f, 0xf, 0x5f, 0x9, 0x5f, 0x9, 0x9f, 0x89, 0x1f, 0x6, 0x1f, 0x0, 0x1f, 0x0, 0x1f, 0x0, 0x9f, 0x0, 0xf, 0x10, 0xf, 0x0, 0xf, 0x0, 0xf, 0x1, 0xf, 0x0, 0xf, 0x7c, 0xf, 0x7f, 0x8f, 0x4f, 0x8f, 0x78, 0x8f, 0x8, 0x9f, 0xf, 0x9f, 0x0, 0x1f, 0x80, 0x1f, 0x0, 0x1f, 0x1, 0x1f, 0x60, 0x1f, 0xf0, 0x1f, 0x90, 0x5f, 0x90, 0x1f, 0x92, 0x1f, 0x60, 0x1f, 0x0, 0x1f, };
	const unsigned char Dock_2[]={0xff, 0xff, 0xff, 0xff, 0xff, 0x49, 0x24, 0x92, 0x49, 0x3f, 0x0, 0x0, 0x0, 0x0, 0x3f, 0x49, 0x24, 0x92, 0x49, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };
	const unsigned char Dock_3[]={0xff, 0xff, 0xff, 0xff, 0xff, 0x49, 0x24, 0x92, 0x49, 0x3f, 0x0, 0x0, 0x0, 0x0, 0x3f, 0x49, 0x24, 0x92, 0x49, 0x3f, 0x49, 0x24, 0x92, 0x49, 0x3f, 0x0, 0x0, 0x0, 0x0, 0x3f, 0x49, 0x24, 0x92, 0x49, 0x3f, 0x49, 0x24, 0x92, 0x49, 0x3f, 0x0, 0x0, 0x0, 0x0, 0x3f, 0x49, 0x24, 0x92, 0x49, 0x3f, 0x49, 0x24, 0x92, 0x49, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };

	int i;
	const unsigned char Y_Boats_Docks[] = {0, 25, 40};

	ML_bmp_or(Dock_1, 65, 0, 12, 64);
	ML_bmp_or(Dock_2, 77, 16, 35, 6);
	ML_bmp_or(Dock_3, 77, 40, 35, 13);

	for(i = 0; i < 3; i++)draw_boat(Boats[i], (Boats[i]+1)*100, 80, Y_Boats_Docks[i]);
}

void draw_reefs(int *Reefs_Grid, int Gap)
{
	const unsigned char Or_Reefs[4][32] = {
		{0x0, 0x40, 0x64, 0x76, 0x77, 0x7f, 0xff, 0xff, },
		{0x20, 0x78, 0x7e, 0x7e, 0xff, 0xff, 0xff, 0xff, },
		{0x22, 0xc, 0x22, 0x9e, 0x37, 0x9e, 0x77, 0xfe, 0x7f, 0xfe, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x30, 0x3, 0xf8, 0x7, 0xf8, 0x7, 0xfc, 0x17, 0xfc, 0x1f, 0xfe, 0x1f, 0xfe, 0x3f, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, }};
	const unsigned char Xor_Reefs[4][32] = {
		{0x0, 0x0, 0x0, 0x0, 0x20, 0x24, 0x54, 0x7a, },
		{0x0, 0x0, 0x18, 0x20, 0x58, 0xc, 0x34, 0x7e, },
		{0x0, 0x0, 0x0, 0x8, 0x2, 0xc, 0x22, 0x18, 0x34, 0xb4, 0x28, 0xaa, 0x55, 0x4c, 0x4b, 0xae, },
		{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x20, 0x3, 0x70, 0x2, 0xa8, 0x1, 0x30, 0x5, 0x90, 0x9, 0x28, 0xb, 0x88, 0x26, 0x4c, 0x54, 0x6a, 0x56, 0xdc, 0x34, 0xfa, 0x5e, 0xf4, }};
	const unsigned char Width_Reefs[] = {8, 8, 16, 16};
	const unsigned char Height_Reefs[] = {8, 8, 8, 16};

	int i, j;

	for(j = 0; j < HEIGHT_GRID_REEFS; j++)for(i = 0; i < WIDTH_GRID_REEFS; i++)if(reef_value(Reefs_Grid, i, j))
	{
		ML_bmp_or_cl(Or_Reefs[reef_value(Reefs_Grid, i, j)-1], -12+8*i-Gap+1, 12+8*j-(Height_Reefs[reef_value(Reefs_Grid, i, j)-1]/16*8), Width_Reefs[reef_value(Reefs_Grid, i, j)-1], Height_Reefs[reef_value(Reefs_Grid, i, j)-1]);		
		ML_bmp_or_cl(Or_Reefs[reef_value(Reefs_Grid, i, j)-1], -12+8*i-Gap, 12+8*j-(Height_Reefs[reef_value(Reefs_Grid, i, j)-1]/16*8), Width_Reefs[reef_value(Reefs_Grid, i, j)-1], Height_Reefs[reef_value(Reefs_Grid, i, j)-1]);
		ML_bmp_xor_cl(Xor_Reefs[reef_value(Reefs_Grid, i, j)-1], -12+8*i-Gap, 12+8*j-(Height_Reefs[reef_value(Reefs_Grid, i, j)-1]/16*8), Width_Reefs[reef_value(Reefs_Grid, i, j)-1], Height_Reefs[reef_value(Reefs_Grid, i, j)-1]);
	}
}

void draw_interface_in_game(int Pv_Total, int Atk_Total, int Score)
{
	const unsigned char Interface_In_Game[]={0xe6, 0x80, 0x0, 0x0, 0x1, 0x9e, 0xd0, 0x0, 0x0, 0x39, 0xcc, 0xe7, 0x87, 0xd6, 0x90, 0x0, 0x0, 0x3, 0x4c, 0xd2, 0x0, 0x0, 0x63, 0x1a, 0xd6, 0x17, 0xe6, 0x80, 0x0, 0x0, 0x3, 0xcc, 0xe0, 0x0, 0x0, 0x33, 0x1a, 0xe7, 0x7, 0xc2, 0x90, 0x0, 0x0, 0x3, 0x4c, 0xd2, 0x0, 0x0, 0x1b, 0x1a, 0xd6, 0x17, 0xc1, 0x0, 0x0, 0x0, 0x3, 0x4c, 0xd0, 0x0, 0x0, 0x71, 0xcc, 0xd7, 0x87, };

	ML_bmp_or(Interface_In_Game, 1, 0, 101, 5);
	draw_number(Pv_Total, 16, 0, BLACK_WHITE, LEFT);
	draw_number(Atk_Total, 59, 0, BLACK_WHITE, LEFT);
	draw_number(Score, 104, 0, BLACK_WHITE, LEFT);
}

void draw_game(int Pv_Total, int Atk_Total, int Score, unsigned char *Boats, int *Pv_Boats, int *X_Grid_Boats, int *Y_Grid_Boats, int *Reefs_Grid, int Gap)
{
	int i;

	draw_reefs(Reefs_Grid, Gap);

	for(i = 0; i < 3; i++)if(Boats[i])draw_boat(Boats[i], Pv_Boats[i], -12+8*X_Grid_Boats[i], 4+8*Y_Grid_Boats[i]);

	draw_interface_in_game(Pv_Total, Atk_Total, Score);
}

void draw_nop(Type_Nop Nop)
{ 

	const unsigned char Picture_Nop[]={ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xbf, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff,
		0x80, 0x4, 0x0, 0x0, 0x0, 0x10, 0x0, 0xff, 0x80, 0xe, 0x0, 0x0, 0x0, 0x38, 0x0, 0xff, 0x80, 0xe, 0x0, 0x0, 0x0, 0x38,
		0x0, 0xff, 0x80, 0x1b, 0x8, 0x9c, 0xf0, 0x6c, 0x0, 0xff, 0x80, 0x1b, 0xc, 0xa2, 0x88, 0x6c, 0x0, 0xff, 0x80, 0x3b, 0x8a,
		0xa2, 0xf0, 0xee, 0x0, 0xff, 0x80, 0x3f, 0x89, 0xa2, 0x80, 0xfe, 0x0, 0xff, 0x80, 0x7b, 0xc8, 0x9c, 0x81, 0xef, 0x0,
		0xff, 0x80, 0x7f, 0xc0, 0x0, 0x1, 0xff, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0,
		0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0,
		0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0,
		0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0,
		0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80,
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff,
		0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
		0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0x83, 0x9c, 0xf3, 0x9c, 0x7, 0xb5, 0xe0, 0xff, 0x83, 0x5a, 0xc6, 0x30,
		0x6, 0x35, 0x80, 0xff, 0x83, 0x9c, 0xe3, 0x18, 0x7, 0x19, 0xc0, 0xff, 0x83, 0x1a, 0xc1, 0x8c, 0x6, 0x35, 0x80, 0xff,
		0x83, 0x1a, 0xf7, 0x38, 0x7, 0xb5, 0xe0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
		0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };
	const unsigned char Picture_Full_Fleet[]={0xe0, 0xcc, 0xe, 0xc0, 0x5, 0x8a, 0x44, 0x8, 0x44, 0x4f, 0xca, 0x44, 0xc, 0x4a, 0xa5, 0x8a, 0x44, 0x8, 0x4c, 0xc5, 0x86, 0xee, 0x8, 0xe6, 0x63, };
	const unsigned char Picture_More_Money[]={0xa0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x7, 0xa4, 0xa0, 0xc4, 0x46, 0xd, 0x12, 0x97, 0xaa, 0xa0, 0xaa, 0xaa, 0xa, 0xab, 0x2f, 0x4a, 0xa0, 0xac, 0xca, 0xa, 0xaa, 0x37, 0x84, 0x60, 0xa6, 0x66, 0xa, 0x92, 0x1f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x8, 0x9c, 0x8b, 0xe8, 0x80, 0x7, 0x0, 0xd, 0xa2, 0xca, 0x5, 0x0, 0x7, 0x0, 0xa, 0xa2, 0xab, 0x82, 0x0, 0x7, 0x0, 0x8, 0xa2, 0x9a, 0x4, 0x0, 0x7, 0x0, 0x8, 0x9c, 0x8b, 0xe8, 0x0, 0x7, };
	const unsigned char Picture_Sell_Last[]={0x50, 0x0, 0x0, 0x9, 0x0, 0x6, 0x67, 0x52, 0x50, 0x66, 0xcb, 0x83, 0x22, 0x27, 0x55, 0x50, 0x8a, 0xa1, 0x6, 0x52, 0x27, 0x25, 0x50, 0x8a, 0xa1, 0x3, 0x62, 0x27, 0x42, 0x30, 0x66, 0xa0, 0x86, 0x37, 0x77, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x18, 0x0, 0x82, 0x0, 0x17, 0xa4, 0xaa, 0x8, 0xcd, 0xc3, 0x11, 0xbf, 0xaa, 0xac, 0x9, 0x58, 0x82, 0xaa, 0x97, 0x4a, 0xa8, 0x9, 0x4c, 0x82, 0xaa, 0x97, 0x84, 0x68, 0x1c, 0xd8, 0x43, 0x11, 0x8f, };

	ML_rectangle(34, 11, 93, 51, 0, 0, 0);
	ML_bmp_or(Picture_Nop, 35, 12, 58, 39);

	switch (Nop)
	{
		case FULL_FLEET : ML_bmp_or(Picture_Full_Fleet, 44, 30, 39, 5); break;
		case MORE_MONEY : ML_bmp_or(Picture_More_Money, 37, 25, 53, 13); break;
		case SELL_LAST : ML_bmp_or(Picture_Sell_Last, 37, 25, 53, 13); break;
	}
}

void draw_game_over(int Score_Miles, int Score_Pirates, int Best, int Money, unsigned char *Boats, int Selection, int Pv_Total, int Atk_Total, int Price_Total)
{

	const unsigned char Picture_Menu_Game_Over[]={ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,
	0x87, 0x8f, 0x31, 0xbe, 0x1e, 0x6d, 0xf7, 0xc3, 0xb2, 0x80, 0x0, 0x0, 0x13, 0xa8, 0x0, 0x3,  0x8c, 0x19, 0xbb, 0xb0,
	0x33, 0x6d, 0x86, 0x63, 0xaa, 0x90, 0x0, 0x0, 0x29, 0x29, 0x0, 0x3,  0x8d, 0xdf, 0xb5, 0xbc, 0x33, 0x6d, 0xe7, 0x83,
	0xb2, 0x80, 0x0, 0x0, 0x39, 0x30, 0x0, 0x3,  0x8c, 0xd9, 0xb1, 0xb0, 0x33, 0x39, 0x86, 0x63, 0xa2, 0x90, 0x0, 0x0,
	0x29, 0x29, 0x0, 0x3,  0x87, 0x99, 0xb1, 0xbe, 0x1e, 0x11, 0xf6, 0x63, 0xa1, 0x0, 0x0, 0x0, 0x29, 0x28, 0x0, 0x3,
	0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x3, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0,
	0x3,  0x81, 0x17, 0x47, 0x30, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x28, 0x0, 0x3,  0x81, 0xb2, 0x44,
	0x40, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x29, 0x13, 0x3,  0x81, 0x52, 0x46, 0x20, 0x0, 0x0, 0x0, 0x3,
	0x80, 0x0, 0x0, 0x0, 0x18, 0x32, 0xaa, 0x83,  0x81, 0x12, 0x44, 0x10, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18,
	0x2b, 0x33, 0x3,  0x81, 0x17, 0x77, 0x60, 0x2, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x29, 0x9a, 0x3,  0x80,
	0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0x8c, 0xec, 0x4e, 0xe6, 0x2, 0x0, 0x0,
	0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x12, 0x1, 0x3,  0x8a, 0x4a, 0xa4, 0x88, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0,
	0x18, 0x3b, 0x1b, 0x83,  0x8c, 0x4c, 0xe4, 0xc4, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x12, 0xa9, 0x3,
	0x88, 0x4a, 0xa4, 0x82, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x12, 0xa9, 0x3,  0x88, 0xea, 0xa4, 0xec,
	0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0xa, 0x98, 0x83,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0,
	0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0x9f, 0xff, 0xff, 0xff, 0x0, 0xf, 0xff, 0xfb, 0x80, 0x0, 0x0, 0x0, 0x18, 0x2c, 0x0,
	0x43,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x44, 0x44, 0xe3,  0x80, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0xe4, 0xaa, 0x43,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80,
	0x0, 0x0, 0x0, 0x18, 0x44, 0xcc, 0x43,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x4e,
	0x66, 0x23,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x2, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80,
	0x0, 0x0, 0x0, 0x18, 0x4, 0x4a, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0xe,
	0xac, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0xe0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x4, 0xa8, 0x3,  0x80, 0x0, 0x0,
	0x0, 0x0, 0x40, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x4, 0x48, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80,
	0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0,
	0x23,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x7b,  0x80, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0xa3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0,
	0x0, 0x0, 0x18, 0x0, 0x0, 0x73,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x2b,
	0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0xf3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x23,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0,
	0x18, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xfb, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0x80,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0xa2, 0x72, 0x2f, 0xa2, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0,
	0x18, 0x0, 0x0, 0x3,  0xb6, 0x8b, 0x28, 0x14, 0xe0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x6, 0xbc, 0xe3,
	0xaa, 0x8a, 0xae, 0x8, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x6, 0xb1, 0x83,  0xa2, 0x8a, 0x68, 0x10,
	0xe0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x6, 0xb8, 0xc3,  0xa2, 0x72, 0x2f, 0xa0, 0x0, 0x0, 0x0, 0x3, 0x80,
	0x0, 0x0, 0x0, 0x19, 0x83, 0x30, 0x63,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x1b, 0xc6,
	0x3d, 0xc3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x1a, 0xc0, 0x0, 0x3,  0xbf, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0, 0x18, 0xc0, 0x0, 0x3,  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0x80, 0x0, 0x0, 0x0, 0x19, 0x81, 0x89, 0x83,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0,
	0x19, 0x81, 0xcb, 0x43,  0xbc, 0xf9, 0xef, 0x80, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x1, 0xab, 0x43,
	0xa2, 0x82, 0x2, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x19, 0x81, 0x9b, 0x43,  0xbc, 0xe1, 0xc2, 0x0, 0x60,
	0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x1, 0x89, 0x83,  0xa2, 0x80, 0x22, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0,
	0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0xbc, 0xfb, 0xc2, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,
	0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0xbf, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xbf, 0xff, 0xff, 0xff, 0xfb, 0xff, 0xff, 0xff,  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };

	const unsigned char Picture_New_Best[]={0xce, 0x88, 0xce, 0x6f, 0xa8, 0x88, 0xa8, 0x85, 0xac, 0xa8, 0xcc, 0x45, 0xa8, 0xa8, 0xa8, 0x25, 0xae, 0x50, 0xce, 0xc5, };
	const unsigned char Picture_Score[]={0x66, 0x4c, 0xff, 0x88, 0xaa, 0x9f, 0x48, 0xac, 0xdf, 0x28, 0xaa, 0x9f, 0xc6, 0x4a, 0xff, };

	int i;

	ML_bmp_or(Picture_Menu_Game_Over, 0, 0, 128, 64);
	if(Score_Miles+Score_Pirates > Best)ML_bmp_or(Picture_New_Best, 2, 26, 31, 5);
	else ML_bmp_or(Picture_Score, 8, 26, 19, 5);
	draw_number(Score_Miles, 57, 11, BLACK, RIGHT);
	draw_number(Score_Pirates, 57, 17, BLACK, RIGHT);
	draw_number(Score_Miles+Score_Pirates, 57, 26, BLACK, RIGHT);
	draw_number(Money, 57, 36, BLACK, RIGHT);
	draw_number(Score_Miles+Score_Pirates+Money, 57, 46, BLACK, RIGHT);
	draw_number(Best, 38, 56, BLACK, LEFT);
	for(i = 0; i < 3; i++)draw_boat(Boats[i], (Boats[i]+1)*100, 82-4*Boats[i], 11+i*17);
	draw_number(Pv_Total, 78, 2, BLACK, LEFT);
	draw_number(Atk_Total, 114, 2, BLACK, LEFT);
	draw_number(Price_Total, 109, 36, BLACK, CENTER);
	draw_selection(3, Selection);
}

void draw_menu(int Menu, int Selection, int Best, int Money, unsigned char *Boats, unsigned char Buy_Boat, int Sell_Boat)
{
	const unsigned char Picture_Menu_0[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0,0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0xe6, 0x19, 0xa0, 0x7, 0xb5, 0xef, 0x1, 0x80, 0xd6, 0x35, 0xa0,0x6, 0x34, 0xc6, 0x1, 0x80, 0xe6, 0x3d, 0xa0, 0x7, 0x18, 0xc6, 0x1, 0x80, 0xc6, 0x34, 0xc0, 0x6, 0x34, 0xc6, 0x1, 0x80,0xc7, 0xb5, 0x80, 0x7, 0xb5, 0xe6, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
		0x1, 0x80, 0x0, 0x0, 0xf, 0xf0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x7f, 0xfe, 0x0, 0x0, 0x1, 0x80, 0x0, 0x1, 0xfc, 0x3f,0x80, 0x0, 0x1, 0x80, 0x0, 0x7, 0xf8, 0x1f, 0xe0, 0x0, 0x1, 0x80, 0x0, 0xf, 0xf9, 0xff, 0xf0, 0x0, 0x1, 0x80, 0x0, 0x18,0x78, 0x7e, 0x18, 0x0, 0x1, 0x80, 0x0, 0x30, 0x39, 0xfc, 0xc, 0x0, 0x1, 0x80, 0x0, 0x73, 0xf8, 0x1c, 0xce, 0x0, 0x1,0x80, 0x0, 0xf8, 0x7c, 0x3c, 0xf, 0x0, 0x1, 0x80, 0x0, 0xff, 0x3f, 0xfc, 0xcf, 0x0, 0x1, 0x80, 0x1, 0xf0, 0x3f, 0xfc,
		0xcf, 0x80, 0x1, 0x80, 0x1, 0xd8, 0x78, 0x1d, 0xeb, 0x80, 0x1, 0x80, 0x3, 0xff, 0xe3, 0xc7, 0xff, 0xc0, 0x1, 0x80, 0x3,0xbf, 0xcf, 0xf3, 0xfd, 0xc0, 0x1, 0x80, 0x3, 0xff, 0x9f, 0xf9, 0xff, 0xc0, 0x1, 0x80, 0x7, 0x7, 0xb8, 0x1d, 0xe0, 0xe0,0x1, 0x80, 0x6, 0xfb, 0x3, 0x80, 0xdf, 0x60, 0x1, 0x80, 0x5, 0xbd, 0x3b, 0x4e, 0xbd, 0xa0, 0x1, 0x80, 0x7, 0xff, 0x63,0x98, 0xff, 0xe0, 0x1, 0x80, 0x7, 0xbf, 0x63, 0x18, 0xfd, 0xe0, 0x1, 0x80, 0x7, 0xbf, 0x38, 0xe, 0xfd, 0xe0, 0x1, 0x80,
		0x7, 0xff, 0x0, 0x0, 0xff, 0xe0, 0x1, 0x80, 0x7, 0xff, 0x8e, 0x31, 0xff, 0xe0, 0x1, 0x80, 0x3, 0xc1, 0x91, 0x89, 0xb7,0xc0, 0x1, 0x80, 0x3, 0xc0, 0xcc, 0x73, 0x33, 0xc0, 0x1, 0x80, 0x3, 0xcc, 0xe0, 0x7, 0x33, 0xc0, 0x1, 0x80, 0x1, 0xc1,0xf8, 0x1f, 0x3, 0x80, 0x1, 0x81, 0x1, 0xcc, 0xff, 0xff, 0x33, 0x80, 0x11, 0x90, 0x40, 0xcc, 0xbd, 0xc3, 0x33, 0x1, 0x1,0x86, 0x20, 0xde, 0x99, 0x81, 0xb7, 0x2, 0x61, 0xa0, 0x0, 0x7f, 0x99, 0x9f, 0xfe, 0x0, 0x5, 0x89, 0xfc, 0x3f, 0x99,
		0xc3, 0xfc, 0x3f, 0x91, 0x87, 0xdf, 0x1f, 0x99, 0xf9, 0xf8, 0xfb, 0xe1, 0x88, 0x37, 0x8f, 0x81, 0x81, 0xf1, 0xec, 0x11,0x97, 0x9, 0xc7, 0xc3, 0xc3, 0xe3, 0x90, 0xe9, 0x98, 0x86, 0xe1, 0xff, 0xff, 0x87, 0x61, 0x19, 0x81, 0x41, 0x70, 0x7f,0xfe, 0xe, 0x82, 0x81, 0xc4, 0x60, 0xbc, 0xf, 0xf0, 0x3d, 0x6, 0x23, 0xe0, 0xff, 0xff, 0x80, 0x1, 0xff, 0xff, 0x7, 0xff,0xff, 0xff, 0xe0, 0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0xfe, 0x49, 0x4,
		0x10, 0x4f, 0xff, 0xff, 0xf5, 0x5e, 0x4f, 0x24, 0x93, 0xff, 0xff, 0xc0, 0x73, 0x5e, 0x39, 0x1c, 0x11, 0xce, 0x3, 0xff,0xf5, 0xbe, 0x49, 0x24, 0x93, 0xcf, 0xff, 0xff, 0xf3, 0x7e, 0x49, 0x24, 0x93, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,0xff, 0xff, 0xff, 0xc7, 0xff, 0xdb, 0xff, 0xb1, 0xb7, 0xf2, 0x73, 0xde, 0xd7, 0x8b, 0xdf, 0x35, 0x17, 0xee, 0xaf, 0xcd,0x4f, 0xd9, 0xaf, 0xb1, 0xb3, 0xee, 0x6f, 0xdd, 0x5f, 0xda, 0x9f, 0xb5, 0xb5, 0xee, 0xef, 0xde, 0xdf, 0xea, 0xcf, 0x11,0xd5, 0xf2, 0xf3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };	
	const unsigned char Picture_Menu_1[]={ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0x80, 0x0, 0x0, 0x0, 0x0,
		0x0, 0x0, 0x1,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0,
		0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80,
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0xff, 0xff, 0xff, 0xff, 0xff,
		0xff, 0xff, 0xff,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,  0xbc, 0xf9, 0xef, 0x80, 0x0, 0x0, 0x0, 0x3,  0xa2,
		0x82, 0x2, 0x0, 0x0, 0x0, 0x0, 0x3,  0xbc, 0xe1, 0xc2, 0x0, 0x60, 0x0, 0x0, 0x3,  0xa2, 0x80, 0x22, 0x0, 0x0, 0x0,
		0x0, 0x3,  0xbc, 0xfb, 0xc2, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0,
		0x0, 0x0, 0x0, 0x0, 0x3,  0xa2, 0x72, 0x2f, 0xa2, 0x0, 0x0, 0x0, 0x3,  0xb6, 0x8b, 0x28, 0x14, 0x0, 0x0, 0x0, 0x3,
		0xaa, 0x8a, 0xae, 0x8, 0x60, 0x0, 0x0, 0x3,  0xa2, 0x8a, 0x68, 0x10, 0x0, 0x0, 0x0, 0x3,  0xa2, 0x72, 0x2f, 0xa0,
		0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,  0x80, 0x0, 0x0, 0x0, 0x0,
		0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x83, 0x9a, 0x76, 0x80, 0x0, 0xe6, 0xb4, 0x3,  0x83, 0x5a,
		0xc6, 0x80, 0x0, 0xd6, 0xb4, 0x3,  0x83, 0x9a, 0x67, 0x80, 0x0, 0xe6, 0xb4, 0x3,  0x83, 0x5a, 0x36, 0x80, 0x0, 0xd6,
		0x98, 0x3,  0x83, 0x4c, 0xe6, 0x80, 0x0, 0xe3, 0x30, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0,
		0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x8c, 0x5e, 0xc5, 0xa0, 0x1, 0xde, 0xc6, 0x3,
		0x8e, 0xd8, 0xe5, 0xa0, 0x3, 0x18, 0xc6, 0x3,  0x8d, 0x5c, 0xd5, 0xa0, 0x1, 0x9c, 0xc6, 0x3,  0x8c, 0x58, 0xcd,
		0xa0, 0x0, 0xd8, 0xc6, 0x3,  0x8c, 0x5e, 0xc4, 0xc0, 0x3, 0x9e, 0xf7, 0x83,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
		0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xbf, 0xff, 0xff, 0xff,
		0xff, 0xff, 0xff, 0xff,  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,
		0xbc, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xa2, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xbc, 0x88, 0x3, 0x0, 0x0,
		0x0, 0x0, 0x3,  0xa0, 0x50, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xa0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0,
		0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,
		0x9c, 0xfa, 0x20, 0x0, 0x0, 0x8, 0x20, 0x23,  0xa2, 0x22, 0x40, 0x0, 0x0, 0x8, 0x28, 0x23,  0xbe, 0x23, 0x83, 0x0,
		0x0, 0x11, 0xa1, 0xab,  0xa2, 0x22, 0x40, 0x0, 0x0, 0x22, 0x2a, 0x33,  0xa2, 0x22, 0x20, 0x0, 0x0, 0x21, 0xa9, 0xab,
		0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0xff, 0xff, 0xff, 0xff,
		0xff, 0xff, 0xff, 0xff, };
	const unsigned char Picture_Menu_2[]={ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0x80, 0x0, 0x0, 0x0, 0x0,
		0x0, 0x0, 0x1,  0xa2, 0x72, 0x2f, 0xa2, 0x0, 0x0, 0x0, 0x3,  0xb6, 0x8b, 0x28, 0x14, 0x0, 0x0, 0x0, 0x3,  0xaa,
		0x8a, 0xae, 0x8, 0x60, 0x0, 0x0, 0x3,  0xa2, 0x8a, 0x68, 0x10, 0x0, 0x0, 0x0, 0x3,  0xa2, 0x72, 0x2f, 0xa0, 0x0,
		0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0xff,
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0x80, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x1,  0x80, 0x0, 0x0, 0x0, 0x18,
		0x80, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x19, 0xe0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x1a, 0x80, 0x0, 0x3,  0x80, 0x0,
		0x0, 0x0, 0x19, 0xc7, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x18, 0xa0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x1b, 0xc0, 0x0,
		0x3,  0x80, 0x0, 0x0, 0x0, 0x18, 0x80, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0,
		0x1b, 0x28, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x1a, 0xa8, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x1b, 0x2b, 0x80, 0x3,
		0x80, 0x0, 0x0, 0x0, 0x1a, 0x28, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x1a, 0x10, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x18,
		0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x19, 0x3a, 0x80, 0x3,  0x80, 0x0,
		0x0, 0x0, 0x1a, 0x92, 0x80, 0x3,  0xbf, 0xff, 0xff, 0xff, 0xfb, 0x93, 0x38, 0x3,  0xff, 0xff, 0xff, 0xff, 0xfa,
		0x92, 0x80, 0x3,  0x80, 0x0, 0x0, 0x0, 0x2, 0x92, 0x80, 0x3,  0x8b, 0x90, 0x0, 0xee, 0x80, 0x0, 0x0, 0x3,  0x9a,
		0x30, 0x0, 0x88, 0xc0, 0x0, 0x0, 0x3,  0xbb, 0x10, 0x70, 0xce, 0xe0, 0x0, 0x0, 0x3,  0x9a, 0x10, 0x0, 0x8a, 0xc0,
		0x0, 0x0, 0x3,  0x8a, 0x38, 0x0, 0x8e, 0x80, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0,
		0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x81, 0x8b, 0xd8, 0xb4, 0x1, 0xcd, 0x68, 0x3,  0x81, 0xdb, 0x1c, 0xb4, 0x1, 0xad,
		0x68, 0x3,  0x81, 0xab, 0x9a, 0xb4, 0x1, 0xcd, 0x68, 0x3,  0x81, 0x8b, 0x19, 0xb4, 0x1, 0xad, 0x30, 0x3,  0x81,
		0x8b, 0xd8, 0x98, 0x1, 0xc6, 0x60, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0,
		0x0, 0x3,  0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,  0x80,
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1,  0xbc, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xa2, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0,
		0x3,  0xbc, 0x88, 0x3, 0x0, 0x0, 0x0, 0x0, 0x3,  0xa0, 0x50, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xa0, 0x20, 0x0, 0x0,
		0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x80, 0x0,
		0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0x9c, 0xfa, 0x20, 0x0, 0x0, 0x8, 0x20, 0x23,  0xa2, 0x22, 0x40, 0x0, 0x0, 0x8, 0x28,
		0x23,  0xbe, 0x23, 0x83, 0x0, 0x0, 0x11, 0xa1, 0xab,  0xa2, 0x22, 0x40, 0x0, 0x0, 0x22, 0x2a, 0x33,  0xa2, 0x22,
		0x20, 0x0, 0x0, 0x21, 0xa9, 0xab,  0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,  0xbf, 0xff, 0xff, 0xff, 0xff, 0xff,
		0xff, 0xff,  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };	
	const unsigned char Picture_Menu_4[]={ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0,
		0x0, 0x0, 0x1, 0xa2, 0x72, 0x2f, 0xa2, 0x0, 0x0, 0x0, 0x3, 0xb6, 0x8b, 0x28, 0x14, 0x0, 0x0, 0x0, 0x3, 0xaa, 0x8a,
		0xae, 0x8, 0x60, 0x0, 0x0, 0x3, 0xa2, 0x8a, 0x68, 0x10, 0x0, 0x0, 0x0, 0x3, 0xa2, 0x72, 0x2f, 0xa0, 0x0, 0x0, 0x0,
		0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
		0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x3,
		0x80, 0x0, 0x7, 0x80, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x7, 0x1c, 0x0, 0x0,
		0x0, 0x3, 0x80, 0x0, 0x2, 0x80, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0xf, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x2, 0x0,
		0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0xc, 0xa0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0,
		0xa, 0xa0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0xc, 0xae, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x8, 0xa0, 0x0, 0x0, 0x0, 0x3,
		0x80, 0x0, 0x8, 0x40, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0,
		0x0, 0x3, 0x80, 0x0, 0x4, 0xea, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0xa, 0x4a, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0xe, 0x4c,
		0xe0, 0x0, 0x0, 0x3, 0x80, 0x0, 0xa, 0x4a, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0xa, 0x4a, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0,
		0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3,
		0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x8c, 0x5e, 0xc5, 0xa0, 0x1, 0xde, 0xc6, 0x3, 0x8e, 0xd8, 0xe5, 0xa0, 0x3,
		0x18, 0xc6, 0x3, 0x8d, 0x5c, 0xd5, 0xa0, 0x1, 0x9c, 0xc6, 0x3, 0x8c, 0x58, 0xcd, 0xa0, 0x0, 0xd8, 0xc6, 0x3, 0x8c,
		0x5e, 0xc4, 0xc0, 0x3, 0x9e, 0xf7, 0x83, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0,
		0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0,
		0x0, 0x0, 0x0, 0x3, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
		0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xbc, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xa2, 0x88, 0x0, 0x0, 0x0, 0x0,
		0x0, 0x3, 0xbc, 0x88, 0x3, 0x0, 0x0, 0x0, 0x0, 0x3, 0xa0, 0x50, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xa0, 0x20, 0x0, 0x0,
		0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0,
		0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x9c, 0xfa, 0x20, 0x0, 0x0, 0x8, 0x20, 0x23, 0xa2, 0x22, 0x40, 0x0, 0x0, 0x8, 0x28,
		0x23, 0xbe, 0x23, 0x83, 0x0, 0x0, 0x11, 0xa1, 0xab, 0xa2, 0x22, 0x40, 0x0, 0x0, 0x22, 0x2a, 0x33, 0xa2, 0x22, 0x20,
		0x0, 0x0, 0x21, 0xa9, 0xab, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

	const unsigned char Arrow[]={0x30, 0x5f, 0x81, 0x5f, 0x30, };

	int i;
	int Pv = 0, Atk = 0;

	int Y_Sell_Boat;
	const unsigned short Price_Boat[] = {100, 250, 425, 600};

	if(Menu == 0)ML_bmp_or(Picture_Menu_0, 0, 0, 64, 64);
	else if (Menu >= 1)
	{
		if(Menu == 1)
		{
			ML_bmp_or(Picture_Menu_1, 0, 0, 64, 64);
			draw_number(Best, 38, 11, BLACK, LEFT);
			draw_number(Money, 38, 18, BLACK, LEFT);
		}
		else if(Menu >= 2)
		{
			draw_number(Money, 38, 2, BLACK, LEFT);
			if(Menu == 2)
			{
				ML_bmp_or(Picture_Menu_2, 0, 0, 64, 64);
				draw_boat(Buy_Boat+1, (Buy_Boat+2)*100, 14-4*Buy_Boat, 11);
				draw_number(Price_Boat[Buy_Boat], 58, 12, BLACK, RIGHT);
				draw_number((Buy_Boat+2)*100, 58, 19, BLACK, RIGHT);
				draw_number((Buy_Boat+2)*8, 58, 26, BLACK, RIGHT);
			}
			if(Menu == 4)
			{
				ML_bmp_or(Picture_Menu_4, 0, 0, 64, 64);
				draw_number(Price_Boat[Boats[Sell_Boat]-1]/2, 40, 12, BLACK, RIGHT);
				draw_number((Boats[Sell_Boat]+1)*100, 40, 19, BLACK, RIGHT);
				draw_number((Boats[Sell_Boat]+1)*8, 40, 26, BLACK, RIGHT);
			}		
		}
		for(i = 0; i < 3; i++)if(Boats[i])
		{
			Pv += (Boats[i]+1)*100;
			Atk += (Boats[i]+1)*8;
		}
		draw_number(Pv, 28, 48, BLACK, LEFT);
		draw_number(Atk, 28, 56, BLACK, LEFT);
	}

	draw_selection(Menu, Selection);
	draw_dock(Boats);
	if(Menu == 4)
	{
		if(Sell_Boat == 0)Y_Sell_Boat = 10;
		else Y_Sell_Boat = 34+(Sell_Boat-1)*15;
		ML_rectangle(82+8*Boats[Sell_Boat], Y_Sell_Boat+1, 87+8*Boats[Sell_Boat], Y_Sell_Boat+4, 0, 0, 0);
		ML_bmp_or(Arrow, 81+8*Boats[Sell_Boat], Y_Sell_Boat, 8, 5);
	}
}

void draw_fight(unsigned char *Boats, int *Pv_Boats, int *X_Grid_Boats, int *Y_Grid_Boats, unsigned char *Pirates_Boats, int *Pv_Boats_Pirates, unsigned char *Buttons, int Pv_Total, int Atk_Total, int Score)
{
	const unsigned char Picture_F[3][5] = {
		{0x6f, 0xef, 0x6f, 0x6f, 0xff, },
		{0xff, 0x3f, 0xff, 0xcf, 0xff, },
		{0xff, 0x3f, 0x7f, 0x3f, 0xff, }};
	const unsigned char Picture_Button[2][20] = {
		{0x7f, 0xf3, 0x80, 0xb, 0xbc, 0xf, 0xb0, 0xf, 0xb8, 0xf, 0xb0, 0xf, 0xb0, 0xf, 0x80, 0xf, 0x7f, 0xff, 0x3f, 0xfb, },
		{0x0, 0x3, 0x3f, 0xfb, 0x40, 0x7, 0x5e, 0x7, 0x58, 0x7, 0x5c, 0x7, 0x58, 0x7, 0x58, 0x7, 0x40, 0x7, 0x3f, 0xfb, }};

	int i;
	int Gap_Button;

	for(i = 0; i < 3; i++)
	{
		if(Pirates_Boats[i])
		{
			draw_boat(Pirates_Boats[i], Pv_Boats_Pirates[i], 108-4*Pirates_Boats[i], 4+i*20);
			draw_pv_boat(Pirates_Boats[i], Pv_Boats_Pirates[i], 108-4*Pirates_Boats[i], 4+i*20);
		}
		if(Boats[i])
		{
			draw_boat(Boats[i], Pv_Boats[i], -12+8*X_Grid_Boats[i], 4+8*Y_Grid_Boats[i]);
			draw_pv_boat(Boats[i], Pv_Boats[i], -12+8*X_Grid_Boats[i], 4+8*Y_Grid_Boats[i]);
			if(Y_Grid_Boats[i] < 3)Gap_Button = 1;
			else Gap_Button = 0;
			ML_bmp_or(Picture_Button[Buttons[i]], -12+8*X_Grid_Boats[i], -6+8*Y_Grid_Boats[i]+31*Gap_Button, 14, 10);
			ML_bmp_or(Picture_F[i], -5+8*X_Grid_Boats[i]+Buttons[i], -4+8*Y_Grid_Boats[i]+31*Gap_Button+Buttons[i], 4, 5);
		}
	}
	draw_interface_in_game(Pv_Total, Atk_Total, Score);
}