#include "fxlib.h"
#include "math.h"
#include "stdlib.h"
#include "string.h"
#include "stdio.h"
#include "memory.h"
#include "usefull.h"
#include "MonochromeLib.h"
#include "input.h"
#include "Infos.h"

void create_reefs(int *Reefs_Grid, int *Reef_Wait)
{
	int i;
	for(i = 0; i < rand()%2+2; i ++)if(!(rand()%((*Reef_Wait)*3)))
	{
		Reefs_Grid[(WIDTH_GRID_REEFS-1)+WIDTH_GRID_REEFS*(rand()%HEIGHT_GRID_REEFS)] = rand()%NUMBER_REEFS+1;
		*Reef_Wait = 3;
	}
}

void move_reefs(int *Reefs_Grid, int Pirates)
{
	static Reef_Wait = 0;

	int i, j;

	for(j = 0; j < HEIGHT_GRID_REEFS; j++)for(i = 0; i < WIDTH_GRID_REEFS; i++)if(reef_value(Reefs_Grid, i, j))
	{
		if(i)Reefs_Grid[(i-1)+WIDTH_GRID_REEFS*j] = reef_value(Reefs_Grid, i, j);
		Reefs_Grid[i+WIDTH_GRID_REEFS*j] = 0;
	}

	if(Reef_Wait)Reef_Wait--;

	if(!Pirates)create_reefs(Reefs_Grid, &Reef_Wait);
}

void collisions(int i, unsigned char *Boats, int *X_Grid_Boats, int *Y_Grid_Boats, int *Reefs_Grid, int **Pv_Total, int *Pv_Boats)
{
	int j;
	for(j = 0; j < Boats[i]; j++)
	if(reef_value(Reefs_Grid, X_Grid_Boats[i]+j, Y_Grid_Boats[i]))
	{
		Pv_Boats[i] -= (Pv_Boats[i] >= 100) ? 100 : Pv_Boats[i];
		if(!Pv_Boats[i])Boats[i] = 0;
		**Pv_Total -= (**Pv_Total >= 100) ? 100 : **Pv_Total;
		Reefs_Grid[X_Grid_Boats[i]+j+WIDTH_GRID_REEFS*Y_Grid_Boats[i]] = 0;
	}
}

void move_boats(unsigned char *Boats, int *X_Grid_Boats, int *Y_Grid_Boats, int *Reefs_Grid, int *Pv_Total, int *Pv_Boats)
{
	int i;

	for(i = 0; i < 3; i++)if(Boats[i])
	{
		if(input_trigger(10*(7-i)+8) && Y_Grid_Boats[i] > 0)Y_Grid_Boats[i]--;
		if(input_trigger(10*(7-i)+7) && Y_Grid_Boats[i] < 5)Y_Grid_Boats[i]++;
	
		collisions(i, Boats, X_Grid_Boats, Y_Grid_Boats, Reefs_Grid, &Pv_Total, Pv_Boats);
	}
}

void pirate_fight(unsigned char *Boats, int *X_Grid_Boats, int *Y_Grid_Boats, int *Pv_Boats, int *Atk_Boats, int *Pv_Total, int *Atk_Total, int Score_Miles, int *Score_Pirates)
{
	int i, j;
	unsigned char Pirates_Boats[3] = {0};

	unsigned char Fleets[12][5][3] = {
		{{0, 1, 0}},
		{{0, 2, 0}, {1, 0, 1}},
		{{0, 3, 0}, {1, 2, 0}, {1, 1, 1}},
		{{0, 4, 0}, {1, 3, 0}, {2, 0, 2}, {1, 2, 1}},
		{{1, 4, 0}, {2, 3, 0}, {1, 3, 1}, {2, 1, 2}},
		{{2, 4, 0}, {1, 4, 1}, {3, 0, 3}, {1, 2, 3}, {2, 2, 2}},
		{{3, 4, 0}, {1, 4, 2}, {3, 1, 3}, {2, 3, 2}},
		{{4, 0, 4}, {1, 4, 3}, {2, 4, 2}, {3, 2, 3}},
		{{4, 1, 4}, {3, 4, 2}, {3, 3, 3}},
		{{4, 2, 4}, {3, 4, 3}},
		{{4, 3, 4}},
		{{4, 4, 4}}};
	unsigned char Number_Fleet[] = {1, 2, 3, 4, 4, 5, 4, 4, 3, 2, 1, 1};

	int Fleet_Value = (Score_Miles/50 < 12) ? Score_Miles/50 : 12;
	int Pirates_Fleet = rand()%Number_Fleet[Fleet_Value];

	int Pv_Boats_Pirates[3] = {0}, Atk_Boats_Pirates[3] = {0};
	int Pv_Total_Pirates = 0, Atk_Total_Pirates = 0;

	unsigned char Buttons[3] = {0};

	for(i = 0; i < 3; i++)
	{
		Pirates_Boats[i] = Fleets[Fleet_Value][Pirates_Fleet][i];
		if(Pirates_Boats[i])
		{
			Pv_Boats_Pirates[i] = (Pirates_Boats[i]+1)*100;
			Pv_Total_Pirates += Pv_Boats_Pirates[i];
			Atk_Total_Pirates += (Pirates_Boats[i]+1)*4;
		}
	}

	while(*Pv_Total && Pv_Total_Pirates)
	{
		ML_clear_vram();
		input_update();

		draw_fight(Boats, Pv_Boats, X_Grid_Boats, Y_Grid_Boats, Pirates_Boats, Pv_Boats_Pirates, Buttons, *Pv_Total, *Atk_Total, Score_Miles+(*Score_Pirates));

		setFps(128/FPS);

		ML_display_vram();

		for(i = 0; i < 3; i++)if(Boats[i])
		{
			if(input_press(79-i*10))Buttons[i] = 1;
			else Buttons[i] = 0;
			if(input_trigger(79-i*10))for(j = 2; j > -1; j--)if(Pirates_Boats[j])
			{
				Pv_Total_Pirates -= Pv_Boats_Pirates[j];
				Pv_Boats_Pirates[j] = (Pv_Boats_Pirates[j] > Atk_Boats[i]) ? Pv_Boats_Pirates[j]-Atk_Boats[i] : 0;
				Pv_Total_Pirates += Pv_Boats_Pirates[j];
				if(!Pv_Boats_Pirates[j])
				{
					Atk_Total_Pirates -= (Pirates_Boats[j]+1)*4;
					Pirates_Boats[j] = 0;
				}
				*Score_Pirates += Atk_Boats[i]/4;
			}
		}

		for(i = 2; i > -1; i--)if(Boats[i])
		{
			if(!(rand()%5))
			{
				*Pv_Total -= Pv_Boats[i];
				Pv_Boats[i] = (Pv_Boats[i] > Atk_Total_Pirates) ? Pv_Boats[i]-Atk_Total_Pirates : 0;
				*Pv_Total += Pv_Boats[i];
				if(!Pv_Boats[i])
				{
					*Atk_Total -= Atk_Boats[i];
					Atk_Boats[i] = 0;
					Boats[i] = 0;
				}
			}
			break;
		}

		//while(!key_down(31));
		//Sleep(50);
	}
}

void game(int *Best, int *Money, unsigned char *Boats)
{
	int Selection = 0;
	Type_Action_Selection Action_Selection = NOT_ACTION;

	int i, j;
	int X_Grid_Boats[3] = {0}, Y_Grid_Boats[3] = {0}, Pv_Boats[3] = {0}, Atk_Boats[3] = {0};
	int Pv_Total = 0, Atk_Total = 0, Price_Total = -100;
	int Score_Miles = 0, Score_Pirates = 0;

	unsigned char Boats_Initial[3] = {0};

	int Reefs_Grid[WIDTH_GRID_REEFS*HEIGHT_GRID_REEFS] = {0};

	//int Frames = 0;
	int Gap = 0;
	int Speed = 8, Speed_Buffer = 0;

	int Create_Pirates_Buffer = 2, Pirates = 0, Reefs_Out_Buffer = 0;

	const unsigned short Price_Boat[] = {100, 250, 425, 600};

	j = (Boats[0] == 4) ? 1 : 2;

	for(i = 0; i < 3; i++)if(Boats[i])
	{
		X_Grid_Boats[i] = j;
		//j += Boats[i];
		j += 4;
		Y_Grid_Boats[i] = 1+i*2;
		Pv_Boats[i] = (Boats[i]+1)*100;
		Atk_Boats[i] = (Boats[i]+1)*8;
		Pv_Total += Pv_Boats[i];
		Atk_Total += Atk_Boats[i];
		Price_Total += Price_Boat[Boats[i]-1];
		Boats_Initial[i] = Boats[i];
	}

	while(Pv_Total)
	{
		ML_clear_vram();
		input_update();

		draw_game(Pv_Total, Atk_Total, Score_Miles+Score_Pirates, Boats, Pv_Boats, X_Grid_Boats, Y_Grid_Boats, Reefs_Grid, Gap);

		//draw_number(Gap, 100, 10, BLACK, LEFT);

		setFps(128/FPS);
		//Frames = (Frames+1)%FPS;
		ML_display_vram();

		//while(!key_down(31));
		//while(key_down(31));

		//if(Speed_Buffer%(Speed/2) == 0)Gap = (Gap+1)%8;

		if(Speed > 1)Speed = 8-(Score_Miles/50);

		Speed_Buffer++;
		if(Speed_Buffer == Speed)
		{
			move_reefs(Reefs_Grid, Pirates);
			Speed_Buffer = 0;
			Score_Miles++;

			if(Create_Pirates_Buffer > 1 && rand()%4)Create_Pirates_Buffer = (Create_Pirates_Buffer+1)%25;
			if(Create_Pirates_Buffer == 0)
			{
				Pirates = 1;
				Create_Pirates_Buffer = 1;
			}
			if(Create_Pirates_Buffer == 1)
			{
				Reefs_Out_Buffer++;
			}
			if(Reefs_Out_Buffer == 22)
			{
				pirate_fight(Boats, X_Grid_Boats, Y_Grid_Boats, Pv_Boats, Atk_Boats, &Pv_Total, &Atk_Total, Score_Miles, &Score_Pirates);
				Reefs_Out_Buffer = 0;
				Create_Pirates_Buffer = 2;
				Pirates = 0;
			}
		}

		move_boats(Boats, X_Grid_Boats, Y_Grid_Boats, Reefs_Grid, &Pv_Total, Pv_Boats);

		if(input_trigger(47))break;
	}

	for(i = 0; i < 3; i++)Boats[i] = Boats_Initial[i];

	while(Action_Selection == NOT_ACTION)
	{
		ML_clear_vram();
		input_update();

		selection(3, &Selection, &Action_Selection);

		draw_game_over(Score_Miles, Score_Pirates, *Best, *Money, Boats, Selection, Pv_Total, Atk_Total, Price_Total);

		setFps(128/FPS);

		ML_display_vram();

		if(Action_Selection == YES)
		{
			if(*Money < Price_Total)
			{
				nop(MORE_MONEY);
				Action_Selection = NOT_ACTION;
			}
			else *Money -= Price_Total;
		}
		else if(Action_Selection == NO)
		{
			for(i = 0; i < 3; i++)Boats[i] = 0;
			Boats[1] = 1;
		}
	}

	if(Score_Miles+Score_Pirates > *Best)*Best = Score_Miles+Score_Pirates;
	*Money = (*Money+Score_Miles+Score_Pirates < 999999) ? *Money+Score_Miles+Score_Pirates : 999999;
}